/*----- PROTECTED REGION ID(AxisG2Selector.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Selector.cpp
//
// description : C++ source for the AxisG2Selector class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               AxisG2Selector are implemented in this file.
//
// project :     Selector Generation2
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// Author: abrami
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

	// MYCODE-START
	// MYCODE-END

#include <AxisG2Selector.h>
#include <AxisG2SelectorClass.h>

#define STRINGSIZE 128

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector.cpp

/**
 *  AxisG2Selector class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name       |  Method name
//================================================================
//  State              |  Inherited (no method)
//  Status             |  Inherited (no method)
//  GetInstrumentList  |  get_instrument_list
//  AxisInit           |  axis_init
//  Stop               |  stop
//  Save               |  save
//  GetTPos            |  get_tpos
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Instrument      |  Tango::DevString	Scalar
//  Selector        |  Tango::DevShort	Scalar
//  DeviceState     |  Tango::DevUShort	Scalar
//  DeviceStatus    |  Tango::DevString	Scalar
//  Updater         |  Tango::DevULong	Scalar
//  TrajectoryFSM   |  Tango::DevString	Scalar
//  UserConfig      |  Tango::DevBoolean	Scalar
//  ExtStatus       |  Tango::DevString	Spectrum  ( max = 100)
//  UserConfigData  |  Tango::DevString	Spectrum  ( max = 1000)
//  History         |  Tango::DevString	Spectrum  ( max = 2000)
//================================================================

namespace AxisG2Selector_ns
{
/*----- PROTECTED REGION ID(AxisG2Selector::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::AxisG2Selector()
 *	Description : Constructors for a Tango device
 *                implementing the classAxisG2Selector
 */
//--------------------------------------------------------
AxisG2Selector::AxisG2Selector(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(AxisG2Selector::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::constructor_1
}
//--------------------------------------------------------
AxisG2Selector::AxisG2Selector(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(AxisG2Selector::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::constructor_2
}
//--------------------------------------------------------
AxisG2Selector::AxisG2Selector(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(AxisG2Selector::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void AxisG2Selector::delete_device()
{
	DEBUG_STREAM << "AxisG2Selector::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::delete_device) ENABLED START -----*/

	#if defined(_DBG_REINIT_DEVICE) || defined(_DBG_DEVICE_INIT_CMD)
		cout << "AxisG2Selector::delete_device() " << device_name << endl;
	#endif

        #ifdef HAVE_SAFETYMANAGER
        	#ifdef _DBG_SM
                	cout << "delete safety_manger" << endl;
        	#endif /* _DBG_SM */

        	if(safety_manger) {
                	delete safety_manger;
                	safety_manger = 0;
                	#ifdef _DBG_SM
                        	cout << "safety_manger deleted" << endl;
                	#endif /* _DBG_SM */
        	}
        #endif

        for (int i=0; i<2000; i++){
                if (attr_History_read[i] != NULL){
                        #ifdef _DBG_HISTORY
                                cout << "Going to delete attr_History_read[" << i << "]" << endl;
                        #endif
                        delete[] attr_History_read[i];
                        attr_History_read[i] = NULL;
                }
        }

        if (hist) {
                delete hist;
                hist = NULL;
        }


	delete tfsm;
	delete fsm;

	vector<sourceDev2_t>::iterator sit;
	for (sit=sources.begin(); sit<sources.end(); sit++){
                if ( (*sit).dp != NULL ){
                        delete (*sit).dp;
                	(*sit).dp = NULL;
		}
	}
	
	//	Delete device allocated objects
        if (*attr_Instrument_read) {
                delete [] *attr_Instrument_read;
                *attr_Instrument_read = 0;
        }

        if (*attr_DeviceStatus_read != NULL){
                delete[] *attr_DeviceStatus_read;
                *attr_DeviceStatus_read = NULL;
        }

        if (*attr_TrajectoryFSM_read != NULL){
                delete[] *attr_TrajectoryFSM_read;
                *attr_TrajectoryFSM_read = NULL;
        }

        for (int i=0; i<100; i++){
                if (attr_ExtStatus_read[i] != NULL){
                        delete[] attr_ExtStatus_read[i];
                        attr_ExtStatus_read[i] = NULL;
                }
        }

        for (int i=0; i<1000; i++){
		if (attr_UserConfigData_read[i] != NULL){
			delete[] attr_UserConfigData_read[i];
			attr_UserConfigData_read[i] = NULL;
		}
        }


	DST.erase (DST.begin(),DST.end());
	sources.erase (sources.begin(),sources.end());
	sources_val.erase (sources_val.begin(),sources_val.end());
	nick2idx.clear();
	trgs.erase (trgs.begin(),trgs.end());
	utrgs.erase (utrgs.begin(),utrgs.end());


	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::delete_device
	delete[] attr_Instrument_read;
	delete[] attr_Selector_read;
	delete[] attr_DeviceState_read;
	delete[] attr_DeviceStatus_read;
	delete[] attr_Updater_read;
	delete[] attr_TrajectoryFSM_read;
	delete[] attr_UserConfig_read;
	delete[] attr_ExtStatus_read;
	delete[] attr_UserConfigData_read;
	delete[] attr_History_read;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void AxisG2Selector::init_device()
{
	DEBUG_STREAM << "AxisG2Selector::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call

	#if defined(_DBG_REINIT_DEVICE) || defined(_DBG_DEVICE_INIT_CMD)
		cout << "AxisG2Selector::init_device() create device " << device_name << endl;
	#endif
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_Instrument_read = new Tango::DevString[1];
	attr_Selector_read = new Tango::DevShort[1];
	attr_DeviceState_read = new Tango::DevUShort[1];
	attr_DeviceStatus_read = new Tango::DevString[1];
	attr_Updater_read = new Tango::DevULong[1];
	attr_TrajectoryFSM_read = new Tango::DevString[1];
	attr_UserConfig_read = new Tango::DevBoolean[1];
	attr_ExtStatus_read = new Tango::DevString[100];
	attr_UserConfigData_read = new Tango::DevString[1000];
	attr_History_read = new Tango::DevString[2000];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(AxisG2Selector::init_device) ENABLED START -----*/
	
	//	Initialize device

	// MYCODE-START

	*attr_Updater_read = 0;

        set_state(Tango::INIT);
        set_status("Initialization");

        #ifdef HAVE_SAFETYMANAGER
        	//prtlog(obj, ": HAVE_SAFETYMANAGER");

        	safety_manger = NULL;

        	vector<string>::iterator srit;
        	bool have_rule = false;
        	for (srit = safetyRules.begin(); srit != safetyRules.end(); ++srit){
                	if ( (*srit).size() > 0 ) have_rule = true;
        	};

        	cout << device_name << " " << (have_rule?"":"not") << " have rules!" << endl;

        	if ( have_rule ){
                	safety_manger = new SafetyManager(this);
                	try {
                        	safety_manger->parseRules(safetyRules);
                		DEBUG_STREAM << "AxisG2Selector::check_rules_validity(): rules parsed!" << endl;
                	} catch(int err) {
                        	Tango::Except::throw_exception("",safety_manger->what(err),"check_rules_validity");
                	};
        	};

        	_delay_safety_manger = 4 ;
        #endif


	attr_UserConfig_read[0] = false;

	#if 0
		*attr_Instrument_read = new char[STRINGSIZE];
        	if(*attr_Instrument_read) {
                	snprintf(*attr_Instrument_read, STRINGSIZE, "-?-");
        	}
	#else
		*attr_Instrument_read=Tango::string_dup("-?-");
	#endif
	
	*attr_Selector_read = 0;
	attr_Instrument_Selector_quality = Tango::ATTR_INVALID;

	*attr_DeviceState_read = 0;
        *attr_DeviceStatus_read = new char[DSTATUSMAX];
        snprintf(*attr_DeviceStatus_read, DSTATUSMAX, "UNKNOWN");

        DST.push_back("UNKNOWN");
        DST.push_back("ONLINE");
        DST.push_back("OFFLINE");
        DST.push_back("SERVICE");
        DST.push_back("TEST");

	*attr_TrajectoryFSM_read=Tango::string_dup("-?-");
        fsm = new TrajectoryFSM(this);

	fsm->init();

	Selector_new_val = -1;

        for (int i=0; i<100; i++){
                attr_ExtStatus_read[i] = new char[STRINGSIZE];
                snprintf(attr_ExtStatus_read[i], STRINGSIZE, "-");
        }

        for (int i=0; i<1000; i++){
                attr_UserConfigData_read[i] = new char[STRINGSIZE];
                snprintf(attr_UserConfigData_read[i], STRINGSIZE, "-");
        }


	bool init_device_ok = true;

	init_device_ok = parseSources(axisDevices, sources);

	vector<sourceDev2_t>::iterator sit;

	#ifdef _DBG_INIT_DEVICE
		cout << endl;
		cout << "DUMPING sources: " << endl;
		for (sit=sources.begin(); sit<sources.end(); sit++){
			cout << "| nickName: " << (*sit).nickName << " | ";
			cout << "dev: " << (*sit).dev << " | ";
			cout << "attr: " << (*sit).attr << " | ";
			cout << "stopcmd: " << (*sit).stopcmd << " | ";
			cout << "initcmd: " << (*sit).initcmd << " | ";
			cout << "tmo: " << (*sit).tmo << " | ";
			cout << endl;
		}
		cout << endl;
		cout << "DUMPING map: " << endl;

		map<string, int>::iterator  mit;

                for (mit = nick2idx.begin(); mit != nick2idx.end(); ++mit){
                        cout << mit->first << " : " << mit->second << endl;
                }


		cout << endl;
	#endif /* _DBG_INIT_DEVICE */

    //==================================================
    // Opening devices:

	for (sit=sources.begin(); sit<sources.end(); sit++){
                (*sit).dp = NULL;
                (*sit).configured = false;
                try {
                        (*sit).dp = new Tango::DeviceProxy((*sit).dev);
			#ifdef _DBG_INIT_DEVICE
                        	cout << (*sit).dev << " ok " << endl;;
			#endif /* _DBG_INIT_DEVICE */
                        (*sit).configured = true;
                        (*sit).state = Tango::UNKNOWN;
                } catch(...) {
			string ss(ag2s_error_str(AG2S_E002));
			ss.append(" : exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
			cout << ss << endl;
        		append_status(ss, true);
			init_device_ok &= false;
                }

	}

    //==================================================
    // Read attr for their types:

	for (sit=sources.begin(); sit<sources.end(); sit++){
		if ((*sit).configured){
	                try {
			  #if 0
				Tango::DeviceAttribute attr = (*sit).dp->read_attribute((*sit).attr);
				//if (attr.get_data_format() != Tango::SCALAR) throw;
				(*sit).data_type = attr.get_type();
				#ifdef _DBG_INIT_DEVICE
					cout << attr << endl;
				#endif /* _DBG_INIT_DEVICE */
			  #else
				//AttributeInfoEx DeviceProxy::get_attribute_config(string&)
				Tango::AttributeInfoEx aie = (*sit).dp->get_attribute_config((*sit).attr);
				(*sit).data_type = aie.data_type;
				#ifdef _DBG_INIT_DEVICE
					cout << (*sit).attr << endl;
				#endif /* _DBG_INIT_DEVICE */
			  #endif
	                } catch(...) {
				string ss(ag2s_error_str(AG2S_E003));
				ss.append(" : exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
				cout << ss << endl;
	        		append_status(ss, true);
				//init_device_ok &= false;
	                }
		}
	}
	#ifdef _DBG_INIT_DEVICE
		cout << endl;
		cout << "DUMPING data_types: " << endl;
		for (sit=sources.begin(); sit<sources.end(); sit++){
			cout << (*sit).nickName << ": " << (*sit).attr << " is a " << Tango::CmdArgTypeName[(*sit).data_type] << endl;
		}
		cout << endl;
	#endif /* _DBG_INIT_DEVICE */

    //==================================================
    // Update __sources property of Instrument attribute (for panel sake):

	vector<string> __srcs_p;
	for (sit=sources.begin(); sit<sources.end(); sit++){
		if ((*sit).configured){
			__srcs_p.push_back((*sit).nickName);
		}
	};
  	Tango::DbData db_data;

        Tango::DbDatum _attr("Instrument");
        _attr << (Tango::DevLong)1 ; // una property
        Tango::DbDatum _attr_prop("__sources");

	try {
        	_attr_prop << __srcs_p;
        	db_data.push_back(_attr);
        	db_data.push_back(_attr_prop);
        	get_db_device()->put_attribute_property(db_data);
	} catch(...) {
		string ss(ag2s_error_str(AG2S_E009));
		ss.append(" : exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
		cout << ss << endl;
	       	append_status(ss, true);
	}



	
    //==================================================
    // Creating targets ....

	#ifdef _DBG_INIT_DEVICE
		cout << "TargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]" << endl << endl;

		cout << "Targets: " << endl;
		for (int i=0; i<targets.size(); i++){
			cout << "   " << targets[i] << endl;
		}
	#endif /* _DBG_INIT_DEVICE */

	if (!parseTargets(targets, trgs)){
			string ss(ag2s_error_str(AG2S_E005));
			cout << ss << endl;
        		append_status(ss, true);
			init_device_ok &= false;
	};

	#ifdef _DBG_INIT_DEVICE
	  {
		cout << endl;
		cout << "DUMPING targets: " << endl;
	        vector<Target>::iterator it_trgs;
		for (it_trgs = trgs.begin(); it_trgs != trgs.end(); it_trgs++){
			cout << it_trgs->name() << " ";
			cout << Tango::DevStateName[it_trgs->stateOnTarget()] << " ";
			{
				vector<target_source_t>::iterator it_src;
				vector<target_source_t> trg_src = it_trgs->trg_src();
				for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
					cout << "  |  ";
					cout << "[" << it_src->source_idx << "] ";
					cout << sourcesIdx2Name(it_src->source_idx) << " ";
					cout << it_src->positionValue << " " << it_src->positionDelta << " ";
				}
			};
			cout << endl;
		};
	  }
	#endif /* _DBG_INIT_DEVICE */

	Tango::DbDatum dbdatum;
	vector<string> utargets;
        try {
		//if (read_memorized_attribute(Tango::DeviceImpl *d, string attr_name, string attr_prop_name, Tango::DbDatum & dbdatum))
		if (read_memorized_attribute(this, "UserConfig", "Targets", dbdatum)){
			vector<string>::iterator ivs;
			dbdatum >> utargets;
			for (ivs=utargets.begin(); ivs!=utargets.end(); ivs++){
                        	cout << (*ivs) << endl;
			}
			
                };
        } catch(Tango::DevFailed &ex) {
		string ss(ag2s_error_str(AG2S_E010));
		cout << ss << endl;
        	append_status(ss, true);
		init_device_ok &= false;
        }
	if (!parseTargets(utargets, utrgs)){
			string ss(ag2s_error_str(AG2S_E011));
			cout << ss << endl;
        		append_status(ss, true);
			init_device_ok &= false;
	};
	#ifdef _DBG_INIT_DEVICE
	  {
		cout << endl;
		cout << "DUMPING utargets: " << endl;
	        vector<Target>::iterator it_trgs;
		for (it_trgs = utrgs.begin(); it_trgs != utrgs.end(); it_trgs++){
			cout << it_trgs->name() << " ";
			cout << Tango::DevStateName[it_trgs->stateOnTarget()] << " ";
			{
				vector<target_source_t>::iterator it_src;
				vector<target_source_t> trg_src = it_trgs->trg_src();
				for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
					cout << "  |  ";
					cout << "[" << it_src->source_idx << "] ";
					cout << sourcesIdx2Name(it_src->source_idx) << " ";
					cout << it_src->positionValue << " " << it_src->positionDelta << " ";
				}
			};
			cout << endl;
		};
	  }
	#endif /* _DBG_INIT_DEVICE */

	trgs_in_use = &trgs;

    //==================================================


	//========== TFSM ========================

        tfsm = new TFSM(this);

	vector<string>::iterator vsit;
	for (vsit=fSMTransitionCommands.begin(); vsit!=fSMTransitionCommands.end(); ++vsit){
		tfsm->addTcmds(*vsit);
	}

	#ifdef _DBG_INIT_DEVICE
		tfsm->dumpTcmds();
	#endif /* _DBG_INIT_DEVICE */

	if (fSMTransitionEnable) tfsm->enable();
	else	tfsm->disable();

	//=======================================

        hist = new History_ns::history(this);
        hist->set_max_sample(2000);

        for (int i=0; i<2000; i++){
                attr_History_read[i] = new char[2];
                sprintf(attr_History_read[i], "-");
                #ifdef _DBG_HISTORY
                        cout << "attr_History_read[" << i << "]=" << attr_History_read[i] << "|" << endl;
                #endif /* _DBG_HISTORY*/
        }

	//=======================================
        std::stringstream ss;
        ss << __func__ << "(done)";
        hist->push_end(ss.str());


	if (init_device_ok) {
		set_state(Tango::ON);
		set_status("Initialization done.");
	} else {
		set_state(Tango::FAULT);
	}
	// MYCODE-END

	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::init_device
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void AxisG2Selector::get_device_property()
{
	/*----- PROTECTED REGION ID(AxisG2Selector::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("AxisDevices"));
	dev_prop.push_back(Tango::DbDatum("Targets"));
	dev_prop.push_back(Tango::DbDatum("Trajectories"));
	dev_prop.push_back(Tango::DbDatum("SafetyRules"));
	dev_prop.push_back(Tango::DbDatum("DefaultState"));
	dev_prop.push_back(Tango::DbDatum("NoTargetValue"));
	dev_prop.push_back(Tango::DbDatum("FSMTransitionNoTargetEnable"));
	dev_prop.push_back(Tango::DbDatum("FSMTransitionCommands"));
	dev_prop.push_back(Tango::DbDatum("FSMTransitionOnMoving"));
	dev_prop.push_back(Tango::DbDatum("FSMTransitionEnable"));
	dev_prop.push_back(Tango::DbDatum("MovementCounter"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on AxisG2SelectorClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		AxisG2SelectorClass	*ds_class =
			(static_cast<AxisG2SelectorClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize AxisDevices from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisDevices;
		else {
			//	Try to initialize AxisDevices from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisDevices;
		}
		//	And try to extract AxisDevices value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisDevices;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize Targets from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  targets;
		else {
			//	Try to initialize Targets from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  targets;
		}
		//	And try to extract Targets value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  targets;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize Trajectories from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  trajectories;
		else {
			//	Try to initialize Trajectories from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  trajectories;
		}
		//	And try to extract Trajectories value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  trajectories;

		//	Try to initialize SafetyRules from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  safetyRules;
		else {
			//	Try to initialize SafetyRules from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  safetyRules;
		}
		//	And try to extract SafetyRules value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  safetyRules;

		//	Try to initialize DefaultState from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  defaultState;
		else {
			//	Try to initialize DefaultState from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  defaultState;
		}
		//	And try to extract DefaultState value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  defaultState;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize NoTargetValue from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  noTargetValue;
		else {
			//	Try to initialize NoTargetValue from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  noTargetValue;
		}
		//	And try to extract NoTargetValue value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  noTargetValue;

		//	Try to initialize FSMTransitionNoTargetEnable from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  fSMTransitionNoTargetEnable;
		else {
			//	Try to initialize FSMTransitionNoTargetEnable from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  fSMTransitionNoTargetEnable;
		}
		//	And try to extract FSMTransitionNoTargetEnable value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  fSMTransitionNoTargetEnable;

		//	Try to initialize FSMTransitionCommands from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  fSMTransitionCommands;
		else {
			//	Try to initialize FSMTransitionCommands from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  fSMTransitionCommands;
		}
		//	And try to extract FSMTransitionCommands value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  fSMTransitionCommands;

		//	Try to initialize FSMTransitionOnMoving from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  fSMTransitionOnMoving;
		else {
			//	Try to initialize FSMTransitionOnMoving from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  fSMTransitionOnMoving;
		}
		//	And try to extract FSMTransitionOnMoving value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  fSMTransitionOnMoving;

		//	Try to initialize FSMTransitionEnable from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  fSMTransitionEnable;
		else {
			//	Try to initialize FSMTransitionEnable from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  fSMTransitionEnable;
		}
		//	And try to extract FSMTransitionEnable value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  fSMTransitionEnable;

		//	Try to initialize MovementCounter from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  movementCounter;
		else {
			//	Try to initialize MovementCounter from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  movementCounter;
		}
		//	And try to extract MovementCounter value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  movementCounter;

	}

	/*----- PROTECTED REGION ID(AxisG2Selector::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void AxisG2Selector::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		append_status(tms.str());
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(AxisG2Selector::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void AxisG2Selector::always_executed_hook()
{
	DEBUG_STREAM << "AxisG2Selector::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"AxisG2Selector::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(AxisG2Selector::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests

        #ifdef HAVE_SAFETYMANAGER
        	if (_delay_safety_manger <= 0){
        		if( safety_manger ) {
                        	#ifdef _DBG_SAFETYMANAGER
                                	cout << device_name << " going to black_box() for SM ... " << endl;
                        	#endif

                		Tango::DevVarStringArray* bb = black_box(1);

                		#ifdef _DBG_SM
                        		cout << "AEH():: !safetyRules.empty():: ";
                        		cout << (bb[0])[0].in() << "|" << endl;
                		#endif /* _DBG_SM */

                		safety_manger->check_action_safety((bb[0])[0].in());
                		delete bb;
        		}
        	} else {
                	_delay_safety_manger--;
        	}
        #endif

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void AxisG2Selector::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2Selector::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void AxisG2Selector::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2Selector::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Instrument related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_Instrument(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_Instrument(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_Instrument) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Instrument_read);
	attr.set_quality(attr_Instrument_Selector_quality);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_Instrument
}
//--------------------------------------------------------
/**
 *	Write attribute Instrument related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::write_Instrument(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_Instrument(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevString	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_Instrument) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	exit_on_fault();
	
	vector<Target>::iterator tit;
	int i = 0;
	for (tit=trgs_in_use->begin(); tit != trgs_in_use->end(); ++tit){
                if ( (*tit).name().compare(w_val) == 0 ) {
			if ( Selector_new_val != i ){
				Selector_new_val = i;
				fsm->fsm(FSMT_GOTO, (*trgs_in_use)[Selector_new_val]);

	        		inc_move_counter(1);
			}
			break;
		}
		i++;
	};

	if (tit == trgs_in_use->end()){
		stringstream ss;
		ss.str("");
		ss << "Error in Instrument value, " << w_val << " ??";
		Tango::Except::throw_exception(
                        (const char *) "Error in Selector value",
                        (const char *) ss.str().c_str(),
                        (const char *) "AxisG2Selector::write_Instrument()");
	}
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_Instrument
}
//--------------------------------------------------------
/**
 *	Read attribute Selector related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_Selector(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_Selector(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_Selector) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Selector_read);
	attr.set_quality(attr_Instrument_Selector_quality);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_Selector
}
//--------------------------------------------------------
/**
 *	Write attribute Selector related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::write_Selector(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_Selector(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_Selector) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	exit_on_fault();

	if ( ((int) w_val < 0) || ((int) w_val >= (int)trgs_in_use->size()) ){
		stringstream ss;
		ss.str("");
		ss << "Error in Selector value, allowed from 0 to " << (trgs_in_use->size() - 1);
		Tango::Except::throw_exception(
                        (const char *) "Error in Selector value",
                        (const char *) ss.str().c_str(),
                        (const char *) "AxisG2Selector::write_Selector()");
	}

	if ( *attr_Selector_read != (int) w_val ){
		fsm->fsm(FSMT_GOTO, (*trgs_in_use)[w_val]);

	        inc_move_counter(1);

	}
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_Selector
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceState related method
 *	Description: enum {
 *                	UNKNOWN,
 *               	ONLINE,
 *                	OFFLINE,
 *                	SERVICE,
 *                	TEST
 *                };
 *               Detto meccanismo permetterebbe al *responsabile del dispositivo* di
 *               ``metterlo`` fuori linea, in manutenzione, etc. etc.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_DeviceState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_DeviceState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_DeviceState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_DeviceState_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_DeviceState
}
//--------------------------------------------------------
/**
 *	Write attribute DeviceState related method
 *	Description: enum {
 *                	UNKNOWN,
 *               	ONLINE,
 *                	OFFLINE,
 *                	SERVICE,
 *                	TEST
 *                };
 *               Detto meccanismo permetterebbe al *responsabile del dispositivo* di
 *               ``metterlo`` fuori linea, in manutenzione, etc. etc.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::write_DeviceState(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_DeviceState(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_DeviceState) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	exit_on_fault();

	*attr_DeviceState_read = w_val;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_DeviceState
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceStatus related method
 *	Description: enum {
 *                	UNKNOWN,
 *               	ONLINE,
 *                	OFFLINE,
 *                	SERVICE,
 *                	TEST
 *                };
 *               Detto meccanismo permetterebbe al *responsabile del dispositivo* di
 *               ``metterlo`` fuori linea, in manutenzione, etc. etc.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_DeviceStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_DeviceStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_DeviceStatus) ENABLED START -----*/

	snprintf(*attr_DeviceStatus_read, DSTATUSMAX, "%s", DST[(*attr_DeviceState_read)].c_str());

	//	Set the attribute value
	attr.set_value(attr_DeviceStatus_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_DeviceStatus
}
//--------------------------------------------------------
/**
 *	Read attribute Updater related method
 *	Description: 
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_Updater(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_Updater(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_Updater) ENABLED START -----*/
	#ifdef _DBG_UPDATER
		cout << "-------------------------------- read_Updater() entering... ";
		cout << "with device state: " << Tango::DevStateName[get_state()] << endl;
	#endif /* _DBG_UPDATER */

	if ( get_state() == Tango::FAULT ) return;

	/*
	typedef struct {
        int source_idx;
        Tango::AttrQuality quality;
        double val;
	} source_state_dval_t;
	*/

        set_status("Sources:");
	string ss;

	//=================================================
	// Update sources

	(*attr_Updater_read)++;

	#ifdef _PROFILE_UPDATER
	struct timeval t0, t1, dt;
	
	gettimeofday(&t0, NULL);
	#endif /* _PROFILE_UPDATER */

	Tango::DevState all_sources_state = Tango::UNKNOWN;
        vector<source_state_dval_t>::iterator svit;
        for (svit = sources_val.begin(); svit != sources_val.end(); ++svit){
		try {
			#ifdef _DBG_UPDATER
				cout << "Update source on: " << sources[(*svit).source_idx].nickName << " ... ";
			#endif /* _DBG_UPDATER */
			ss = "";
			ss += sources[(*svit).source_idx].dev + " ";
			ss += sources[(*svit).source_idx].attr + " ";

			// update state()
			#ifdef _DBG_BUG01_ON_T932
				cout << endl;
				cout << "BUG01_ON_T932: going to dp->state()..." << endl;;
			#endif /* _DBG_BUG01_ON_T932 */

			sources[(*svit).source_idx].state = sources[(*svit).source_idx].dp->state();

			#ifdef _DBG_BUG01_ON_T932
				cout << "BUG01_ON_T932: dp->state(): " << sources[(*svit).source_idx].state << endl;
			#endif /* _DBG_BUG01_ON_T932 */

			ss += Tango::DevStateName[sources[(*svit).source_idx].state];
			append_status(ss, true);

			if (sources[(*svit).source_idx].state == Tango::ALARM){
				ss = " ....: ";
				ss += sources[(*svit).source_idx].dp->status();
				append_status(ss, true);
			}

			// update value
			#ifdef _DBG_BUG01_ON_T932
				cout << "BUG01_ON_T932: going to dp->read_attribute()..." << endl;;
			#endif /* _DBG_BUG01_ON_T932 */

			Tango::DeviceAttribute attr = sources[(*svit).source_idx].dp->read_attribute(sources[(*svit).source_idx].attr);

			#ifdef _DBG_BUG01_ON_T932
				cout << "BUG01_ON_T932: dp->read_attribute()..." << attr << endl;;
			#endif /* _DBG_BUG01_ON_T932 */

			sources[(*svit).source_idx].data_type = attr.get_type();
			#ifdef _DBG_BUG01_ON_T932
				cout << "BUG01_ON_T932: attr.get_type() = " << sources[(*svit).source_idx].data_type << endl;
			#endif /* _DBG_BUG01_ON_T932 */

			/*============================================
			
			Dopo T9.2.5a e sicuramente in T9.3.2 get_type() non genera piu' eccezione
			e CmdArgType = {....
			        	DEVVAR_STATEARRAY,
        				DATA_TYPE_UNKNOWN = 100
			};
			e quindi Tango::CmdArgTypeName[CmdArgType] puo' generare segfault!

			
			============================================*/

                        switch (sources[(*svit).source_idx].data_type){
                                case Tango::DEV_FLOAT:  	float float_val;       attr >> float_val;  (*svit).val = (double)float_val ; break;
                                case Tango::DEV_DOUBLE: 	double double_val;     attr >> double_val; (*svit).val = (double)double_val; break;
                                case Tango::DEV_LONG:   	long long_val;         attr >> long_val;   (*svit).val = (double)long_val; break;
                                case Tango::DEV_USHORT: 	unsigned short us_val; attr >> us_val;     (*svit).val = (double)us_val; break;
                                case Tango::DEV_SHORT: 		short s_val; attr >> s_val;     (*svit).val = (double)s_val; break;
                                case Tango::DATA_TYPE_UNKNOWN: 	
								#if 0
									cout << "Unknown attr_type!" << endl;
								#endif
								Tango::Except::throw_exception(
									"Empty/UnknownDeviceAttribute",
                                        				"cannot extract, no data in DeviceAttribute object ",
                                        				"DeviceAttribute::is_empty"
								);
								break;
                                default:                       	{
								  if (sources[(*svit).source_idx].data_type <= Tango::DEVVAR_STATEARRAY)
								  	cout << "Not implemented attr_type= "<< Tango::CmdArgTypeName[sources[(*svit).source_idx].data_type] << endl;
								  else
								  	cout << "Unknown attr_type!" << endl;
								  throw;
								};
								break;
                        }
			*get_Position_data_ptr(sources[(*svit).source_idx].nickName) = (*svit).val;		
			(*svit).quality = attr.get_quality();
			if ( (attr.get_quality() == Tango::ATTR_VALID) && (sources[(*svit).source_idx].state == Tango::MOVING) ){
				all_sources_state = Tango::MOVING;
				(*svit).quality = Tango::ATTR_CHANGING;
			}
			#ifdef _DBG_UPDATER
				cout << Tango::DevStateName[sources[(*svit).source_idx].state] << endl;
			#endif /* _DBG_UPDATER */
		} catch (Tango::DevFailed &e) {
			#ifdef _DBG_BUG01_ON_T932
				cout << endl << "========================================================" << endl;
				cout << "BUG01_ON_T932: catch (Tango::DevFailed)..." << endl;;
			#endif /* _DBG_BUG01_ON_T932 */
                	string error = "|err msg: " + string(e.errors[0].desc);
			(*svit).quality = Tango::ATTR_INVALID;
			#ifdef _DBG_UPDATER
				cout << "Tango::DevFailed!" << " " << error << " ";
				cout << Tango::DevStateName[sources[(*svit).source_idx].state] << endl;
			#endif /* _DBG_UPDATER */
			#ifdef _DBG_BUG01_ON_T932
				cout << endl << "========================================================" << endl;
			#endif /* _DBG_BUG01_ON_T932 */
		} catch(...) {
			(*svit).quality = Tango::ATTR_INVALID;
			#ifdef _DBG_UPDATER
				cout << "Generic exception!" << endl;
			#endif /* _DBG_UPDATER */
		};
        }
	#ifdef _PROFILE_UPDATER
	gettimeofday(&t1, NULL);
	timersub(&t1, &t0, &dt);

	cout << "read_Updater(" << device_name << "): " << ((float)dt.tv_sec * 1000 + (float)dt.tv_usec / 1000) << " ms" << endl;
	#endif /* _PROFILE_UPDATER */

	//=================================================
	// Update targets / instrument / selector

        CORBA::string_free(*attr_Instrument_read);
       	*attr_Instrument_read = Tango::string_dup(noTargetValue.c_str());
	attr_Instrument_Selector_quality = Tango::ATTR_INVALID;

	Tango::DevState s = Tango::UNKNOWN;

	bool res;
	vector<Target>::iterator tit;


	for (tit=trgs_in_use->begin(); tit != trgs_in_use->end(); ++tit){

		s = Tango::UNKNOWN;

		res = (*tit).update(sources_val);
		res = (*tit).updateState(sources);
		res = (*tit).onTarget();

		#ifdef _DBG_UPDATER
			cout << "UPDATER:: target [" << distance(trgs.begin(),tit) << "] " << (*tit).name() << " " << (res?"on_target":"off_target") << endl;
		#endif /* _DBG_UPDATER */

		#ifdef _DBG_UPDATER_STATE
			cout << "UPDATER::state() = [Pre combineState()= " << Tango::DevStateName[s] << "] trgs_in_use.state() = " << Tango::DevStateName[(*tit).state()]; 
		#endif /* _DBG_UPDATER_STATE */

		s = combineState(s, (*tit).state());

		#ifdef _DBG_UPDATER_STATE
			cout << "  ==> [Post combineState()= " << Tango::DevStateName[s] << "] "; 
		#endif /* _DBG_UPDATER_STATE */

		if (res) {
		        CORBA::string_free(*attr_Instrument_read);
                	*attr_Instrument_read = Tango::string_dup((*tit).name().c_str());
			*attr_Selector_read = (Tango::DevShort) distance(trgs_in_use->begin(),tit);
			attr_Instrument_Selector_quality = Tango::ATTR_VALID;
			//s = (*tit).stateOnTarget();
			s = combineState(s, (*tit).stateOnTarget());

			#ifdef _DBG_UPDATER_STATE
				cout << "  Final ==> " << Tango::DevStateName[s]; 
				cout << endl;
			#endif /* _DBG_UPDATER_STATE */

			break;
		} else {
			*attr_Selector_read = (Tango::DevShort) -1;
		}

		#ifdef _DBG_UPDATER_STATE
			cout << endl;
		#endif /* _DBG_UPDATER_STATE */
	};
	#ifdef _DBG_UPDATER_STATE_INVALID
		std::cout << "UPDATER: " << *attr_Instrument_read << "  selector: " << *attr_Selector_read << " " << AttrQualityName[attr_Instrument_Selector_quality] << std::endl;
	#endif /* _DBG_UPDATER_STATE_INVALID */

	//=================================================
	// Update TFSM

	string new_status(*attr_Instrument_read);
	tfsm->tfsm(new_status);

	if (all_sources_state == Tango::MOVING) s = Tango::MOVING;

        set_state(s);

	//	Set the attribute value
	attr.set_value(attr_Updater_read);
	
	#ifdef _DBG_UPDATER
		cout << "-------------------------------- read_Updater() leaving... ";
		cout << "with device state: " << Tango::DevStateName[get_state()] << endl;
		cout << endl;
	#endif /* _DBG_UPDATER */
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_Updater
}
//--------------------------------------------------------
/**
 *	Read attribute TrajectoryFSM related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_TrajectoryFSM(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_TrajectoryFSM(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_TrajectoryFSM) ENABLED START -----*/

	
	Target fake;
	fake.mode(MODE_NULL);
	fsm->fsm(FSMT_NOP, fake);

        vector<source_state_dval_t>::iterator svit;
        for (svit = sources_val.begin(); svit != sources_val.end(); ++svit){
		if ( sources[(*svit).source_idx].state == Tango::MOVING ) break;
	}
#warning PERCHE
#if 0
	if (
		((svit == sources_val.end()) && (fsm->state() == FSM_WAIT_TARGET)) ||
		((get_state() == Tango::ALARM) && ((fsm->state() != FSM_WAIT)&&(fsm->state() != FSM_START)))
	){
		Target fake;
		fake.mode(MODE_NULL);
		fsm->fsm(FSMT_ABORT, fake);
        	Selector_new_val = -1;
		return;
	}
#endif

	if (fsm->state() == FSM_TARGET_DONE ) {
		Selector_new_val = -1;
	}

        CORBA::string_free(*attr_TrajectoryFSM_read);
	*attr_TrajectoryFSM_read = Tango::string_dup(fsm->status().c_str());

	#ifdef _DBG_FSM
		cout << "NEW FSM: " << *attr_TrajectoryFSM_read << endl;
	#endif /* _DBG_FSM */

	//	Set the attribute value
	attr.set_value(attr_TrajectoryFSM_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_TrajectoryFSM
}
//--------------------------------------------------------
/**
 *	Read attribute UserConfig related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_UserConfig(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_UserConfig(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_UserConfig) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_UserConfig_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_UserConfig
}
//--------------------------------------------------------
/**
 *	Write attribute UserConfig related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::write_UserConfig(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_UserConfig(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_UserConfig) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	*attr_UserConfig_read = w_val;

	if (*attr_UserConfig_read) {
		trgs_in_use = &utrgs;
	} else {
		trgs_in_use = &trgs;
	}
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_UserConfig
}
//--------------------------------------------------------
/**
 *	Read attribute ExtStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
//--------------------------------------------------------
void AxisG2Selector::read_ExtStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_ExtStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_ExtStatus) ENABLED START -----*/

        std::stringstream ss;

        int riga = 0;
        int howmany = 0;


        ss.str("");
        ss << "DEFAULT Config.:";
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        vector<Target>::iterator it_trgs;
        for (it_trgs = trgs.begin(); it_trgs != trgs.end(); it_trgs++){
        	ss.str("");
                ss << "  TARGET: " << it_trgs->name() << " ";
                ss << "  .. state on target: " << Tango::DevStateName[it_trgs->stateOnTarget()];
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;

                {
                	vector<target_source_t>::iterator it_src;
                        vector<target_source_t> trg_src = it_trgs->trg_src();
                        for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
        			ss.str("");
				ss << "       ";
                                ss << "[" << it_src->source_idx << "] ";
                                ss << sourcesIdx2Name(it_src->source_idx) << " ";
                                ss << "pos: " << it_src->positionValue << " +/- " << it_src->positionDelta;
        			ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        			howmany++;
                       }
                };
	};

        ss.str("");
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
        ss << "USER Config.:";
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        for (it_trgs = utrgs.begin(); it_trgs != utrgs.end(); it_trgs++){
        	ss.str("");
                ss << "  TARGET: " << it_trgs->name() << " ";
                ss << "  .. state on target: " << Tango::DevStateName[it_trgs->stateOnTarget()];
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;

                {
                	vector<target_source_t>::iterator it_src;
                        vector<target_source_t> trg_src = it_trgs->trg_src();
                        for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
        			ss.str("");
				ss << "       ";
                                ss << "[" << it_src->source_idx << "] ";
                                ss << sourcesIdx2Name(it_src->source_idx) << " ";
                                ss << "pos: " << it_src->positionValue << " +/- " << it_src->positionDelta;
        			ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        			howmany++;
                       }
                };
	};

	if (fSMTransitionEnable) {
        	ss.str("");
        	ss << "Auto cmds:";
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;

		vector<string> tc = tfsm->str_getTcmds();
		vector<string>::iterator strit;
		for (strit = tc.begin(); strit != tc.end(); ++strit){
        		ss.str("");
			ss << (*strit);
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        		howmany++;
		}
	} else {
        	ss.str("");
        	ss << "Auto cmds: Disabled";
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;
	}


	//	Set the attribute value
        if ( howmany > 100 ) howmany = 100;
        attr.set_value(attr_ExtStatus_read, howmany);


        // MYCODE-END
        // TO BE REMOVED, POGO WROTE IT attr.set_value(attr_ExtStatus_read, 100);

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_ExtStatus
}
//--------------------------------------------------------
/**
 *	Read attribute UserConfigData related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 1000
 */
//--------------------------------------------------------
void AxisG2Selector::read_UserConfigData(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_UserConfigData(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_UserConfigData) ENABLED START -----*/
        std::stringstream ss;

        int riga = 0;
        int howmany = 0;



        vector<Target>::iterator it_trgs;
        for (it_trgs = utrgs.begin(); it_trgs != utrgs.end(); it_trgs++){
        	ss.str("");
                ss << ":TARGET:";
        	ExtStatus(attr_UserConfigData_read, &riga, ss.str());
        	howmany++;

        	ss.str("");
		ss << it_trgs->name();
        	ExtStatus(attr_UserConfigData_read, &riga, ss.str());
        	howmany++;

        	ss.str("");
                ss << Tango::DevStateName[it_trgs->stateOnTarget()];
        	ExtStatus(attr_UserConfigData_read, &riga, ss.str());
        	howmany++;

                {
                	vector<target_source_t>::iterator it_src;
                        vector<target_source_t> trg_src = it_trgs->trg_src();
                        for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
        			ss.str("");
                                ss << sourcesIdx2Name(it_src->source_idx);
        			ExtStatus(attr_UserConfigData_read, &riga, ss.str());
        			howmany++;

        			ss.str("");
                                ss << it_src->positionValue;
        			ExtStatus(attr_UserConfigData_read, &riga, ss.str());
        			howmany++;

        			ss.str("");
				ss << it_src->positionDelta;
        			ExtStatus(attr_UserConfigData_read, &riga, ss.str());
        			howmany++;
                       }
                };
	};
	//	Set the attribute value
	//attr.set_value(attr_UserConfigData_read, 1000);

        if ( howmany > 1000 ) howmany = 1000;
        attr.set_value(attr_UserConfigData_read, howmany);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_UserConfigData
}
//--------------------------------------------------------
/**
 *	Write attribute UserConfigData related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 1000
 */
//--------------------------------------------------------
void AxisG2Selector::write_UserConfigData(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_UserConfigData(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve number of write values
	int	w_length = attr.get_write_value_length();

	//	Retrieve pointer on write values (Do not delete !)
	const Tango::ConstDevString	*w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_UserConfigData) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(...)";
        hist->push_end(ss.str());
	
//AA
	#ifdef _DBG_UCDATA
		for (int i=0; i<w_length; i++){
			cout << "[" << i << "] " << w_val[i] << endl;
		}
		cout << endl;
	#endif
	
	vector<string> newucongif = getUserConfigData(w_val, w_length);

	if (newucongif.size() != trgs.size()){
		Tango::Except::throw_exception(
                	(const char *) "Error N",
                	(const char *) "Error N",
                	(const char *) "AxisG2Selector::write_UserConfigData()");
	}

	#ifdef _DBG_UCDATA
		for (vector<string>::iterator it = newucongif.begin(); it != newucongif.end(); it++){
			cout << *it << endl;
		}
	#endif

	vector<Target> newutrgs;
        if (!parseTargets(newucongif, newutrgs)){
                        string ss(ag2s_error_str(AG2S_E011));
                        cout << ss << endl;
                        append_status(ss, true);
                        Tango::Except::throw_exception (
                        	(const char *)"AxisG2Selector",
                        	(const char *) ss.c_str(),
                        	(const char *)"AxisG2Selector::write_UserConfigData()");
        }

	string msg("");
	if ( !checkTargets(newutrgs, msg) ) {
                        string ss(ag2s_error_str(AG2S_E012));
			ss.append(" [");
			ss += msg;
			ss.append("] ");
                        cout << ss << endl;
                        append_status(ss, true);
                        Tango::Except::throw_exception (
                        	(const char *)"AxisG2Selector",
                        	(const char *) ss.c_str(),
                        	(const char *)"AxisG2Selector::write_UserConfigData()");
	}

	utrgs.clear();
	utrgs = newutrgs;

	Tango::DbDatum _attr_prop("Targets");
        _attr_prop << newucongif;
        if ( !put_memorized_attribute(this, "UserConfig", _attr_prop) ){
                                //INFOLOG("AxisG2Selector::write_UserConfigData(): Error in put new memorized value");
                                Tango::Except::throw_exception (
                                        (const char *)"AxisG2Selector",
                                        (const char *)"Error in put new memorized value",
                                        (const char *)"AxisG2Selector::write_UserConfigData()");
        }

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_UserConfigData
}
//--------------------------------------------------------
/**
 *	Read attribute History related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
//--------------------------------------------------------
void AxisG2Selector::read_History(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_History(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::read_History) ENABLED START -----*/

        int howmany = hist->copyto(attr_History_read);
        if (howmany > 0) attr.set_value(attr_History_read, howmany);

	//	Set the attribute value
	//attr.set_value(attr_History_read, 2000);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_History
}

//--------------------------------------------------------
/**
 *	Read attribute Position related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_Position(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_Position(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_Position_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(AxisG2Selector::read_Position) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(att_value);

	vector<source_state_dval_t>::iterator svit;
        for (svit = sources_val.begin(); svit != sources_val.end(); ++svit){
		if ((*svit).source_idx == nick2idx[attr.get_name()]){
			attr.set_quality((*svit).quality);
			break;
		}
	}
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_Position
}
//--------------------------------------------------------
/**
 *	Write attribute Position related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::write_Position(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_Position(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_Position) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	exit_on_fault();
// WRP

	Tango::DevShort currentTrg = *attr_Selector_read; // anche se ....

	#ifdef _DBG_WRITE_DYN_POSITION
		cout << "currentTrg = " << currentTrg << " ";
		cout << AttrQualityName[attr_Instrument_Selector_quality] << "[" << attr_Instrument_Selector_quality << "] ";
		cout << endl;
	#endif /* _DBG_WRITE_DYN_POSITION */

	switch (attr_Instrument_Selector_quality){
		case Tango::ATTR_VALID: break;
		default:
			{
			string ss("Write not allowed in ");
			ss.append(AttrQualityName[attr_Instrument_Selector_quality]);
			Tango::Except::throw_exception(
					(const char *) AttrQualityName[attr_Instrument_Selector_quality],
					(const char *) ss.c_str(),
					(const char *) "AxisG2Selector::write_Position()");
			}
			break;
	}

	Tango::DeviceAttribute da;
	vector<sourceDev2_t>::iterator sit;
	for (sit=sources.begin(); sit<sources.end(); sit++){
		#ifdef _DBG_WRITE_DYN_POSITION
			cout << "Search: " << attr.get_name() << " process: " << (*sit).nickName << " [" << (*sit).index << "]" << endl;
		#endif /* _DBG_WRITE_DYN_POSITION */

		//
		// get dynamic attribute:
		//
		if ( (*sit).configured && ((*sit).index == nick2idx[attr.get_name()]) ){
			int trg_src_idx = -1;
				// check if new value allowable versus current target
		
			vector<target_source_t> trg = (*trgs_in_use)[currentTrg].trg_src();
                        	for (vector<target_source_t>::iterator tsit=trg.begin(); tsit != trg.end(); ++tsit){
				#ifdef _DBG_WRITE_DYN_POSITION
					cout << "sources.index = "<< (*sit).index << " .. ";
                                		cout << "source_idx= "    << (*tsit).source_idx << "|";
                                		cout << "positionValue= " << (*tsit).positionValue << "|";
                                		cout << "positionDelta= " << (*tsit).positionDelta << " ";
					cout << endl;
				#endif /* _DBG_WRITE_DYN_POSITION */
				if ( (*sit).index == (*tsit).source_idx ){
					trg_src_idx = distance(trg.begin(),tsit);
					#ifdef _DBG_WRITE_DYN_POSITION
						cout << "target source idx = " << trg_src_idx << endl;
					#endif /* _DBG_WRITE_DYN_POSITION */
				}
                        	}

			if (trg_src_idx < 0){
				Tango::Except::throw_exception(
					(const char *) "NOT SOURCE",
					(const char *) "Source not found",
					(const char *) "AxisG2Selector::write_Position()");
			}


			//source found check value
			#ifdef _DBG_WRITE_DYN_POSITION
				cout << "        w_val= " << w_val << endl;
				cout << "positionValue= " << trg[trg_src_idx].positionValue << endl;
				cout << "positionDelta= " << trg[trg_src_idx].positionDelta << endl;
			#endif /* _DBG_WRITE_DYN_POSITION */

			if (fabs(trg[trg_src_idx].positionValue - (double)w_val) > fabs(trg[trg_src_idx].positionDelta)){
				Tango::Except::throw_exception(
					(const char *) "NOT ALLOWED",
					(const char *) "Requested displacement not allowed in this target",
					(const char *) "AxisG2Selector::write_Position()");
				}


	                try {
				da.set_name((*sit).attr);
				//if (attr.get_data_format() != Tango::SCALAR) throw;
                                switch ((*sit).data_type){
                                        case Tango::DEV_FLOAT:  break;
                                        case Tango::DEV_DOUBLE: { double         double_val = (double)w_val;         da << double_val; }; break;
                                        case Tango::DEV_LONG:   { Tango::DevLong   long_val = (Tango::DevLong)w_val; da << long_val; }; break;
                                	case Tango::DEV_USHORT: { unsigned short     us_val = (unsigned short)w_val; da << us_val; }; break;
                                        case Tango::DEV_SHORT:  { short           short_val = (short)w_val; da << short_val; }; break;
                                        default:                cout << "Not implemented attr_type= "<< Tango::CmdArgTypeName[(*sit).data_type];
				}
				#ifdef _DBG_WRITE_DYN_POSITION
					cout << "From " << attr.get_name() << " to " << da.get_name() << endl;
				#endif /* _DBG_WRITE_DYN_POSITION */
				(*sit).dp->write_attribute(da);
	                } catch(...) {
				string ss(ag2s_error_str(AG2S_E004));
				ss.append(" : exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
				cout << ss << endl;
	        		append_status(ss, true);
	                }
			break;
		}
	}
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_Position
}
//--------------------------------------------------------
/**
 *	Read attribute DeltaPosition related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::read_DeltaPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::read_DeltaPosition(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_DeltaPosition_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(AxisG2Selector::read_DeltaPosition) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::read_DeltaPosition
}
//--------------------------------------------------------
/**
 *	Write attribute DeltaPosition related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Selector::write_DeltaPosition(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Selector::write_DeltaPosition(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Selector::write_DeltaPosition) ENABLED START -----*/

        std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	exit_on_fault();
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::write_DeltaPosition
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2Selector::add_dynamic_attributes()
{
	//	Example to add dynamic attribute:
	//	Copy inside the following protected area to create instance(s) at startup.
	//	add_Position_dynamic_attribute("MyPositionAttribute");
	//	add_DeltaPosition_dynamic_attribute("MyDeltaPositionAttribute");
	
	/*----- PROTECTED REGION ID(AxisG2Selector::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	vector<sourceDev2_t>::iterator sit;
	for (sit=sources.begin(); sit<sources.end(); sit++){
                if ((*sit).configured){
			add_Position_dynamic_attribute((*sit).nickName);

			Tango::AttributeInfoEx aie = (*sit).dp->get_attribute_config((*sit).attr);
		        Tango::AttributeConfig att_conf;
		        Tango::Attribute &attr = get_device_attr()->get_attr_by_name((*sit).nickName.c_str());
		        attr.get_properties(att_conf);

        		att_conf.name		= (*sit).nickName.c_str();
        		att_conf.unit		= aie.unit.c_str();
        		att_conf.display_unit	= aie.display_unit.c_str();
        		att_conf.standard_unit  = aie.standard_unit.c_str();

		        try {
		                //attr.set_properties(att_conf, get_name(), from_ds, &v_db);

				bool from_ds(true);

				vector<Tango::Attribute::AttPropDb> v_db;
				attr.set_properties(att_conf, get_name(), from_ds, v_db);

				//upd_database(v_db, get_name());

		        } catch(Tango::DevFailed &e) {
		                cout << e.errors[0].desc << endl;
       		 	}
		};
	};
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command GetInstrumentList related method
 *	Description: 
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevVarStringArray *AxisG2Selector::get_instrument_list()
{
	Tango::DevVarStringArray *argout;
	DEBUG_STREAM << "AxisG2Selector::GetInstrumentList()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::get_instrument_list) ENABLED START -----*/
	
	//	Add your own code



        std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

        argout = new Tango::DevVarStringArray();
        argout->length(trgs_in_use->size());
	vector<Target>::iterator tit;
	int i = 0;
	for (tit=trgs_in_use->begin(); tit != trgs_in_use->end(); ++tit){
                (*argout)[i] = Tango::string_dup((*tit).name().c_str());
		i++;
	};

	// MYCODE-END

	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::get_instrument_list
	return argout;
}
//--------------------------------------------------------
/**
 *	Command AxisInit related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void AxisG2Selector::axis_init()
{
	DEBUG_STREAM << "AxisG2Selector::AxisInit()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::axis_init) ENABLED START -----*/
	
	//	Add your own code

        std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	exit_on_fault();

	#ifdef _GALILSIM_AXISINIT
	#else
		//in realta' non serve, in quanto anche in sourcesAxisInit() si lancia
		//un cmd di stop!!
		//stop();
	#endif

	string err("-.-");
	if ( !sourcesAxisInit(MODE_ALL, err) ){
		Tango::Except::throw_exception(
					(const char *) err.c_str(),
					(const char *)"Error on axis_init",
					(const char *)"AxisG2Selector::axis_init()");
	}

        inc_move_counter(2);

	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::axis_init
}
//--------------------------------------------------------
/**
 *	Command Stop related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void AxisG2Selector::stop()
{
	DEBUG_STREAM << "AxisG2Selector::Stop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::stop) ENABLED START -----*/
	
	//	Add your own code

        std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	#ifdef _DBG_STOP
		cout << "Entering AxisG2Selector::Stop() ..." << endl;
	#endif 

	Target fake;
	fake.mode(MODE_NULL);
	fsm->fsm(FSMT_ABORT, fake);
        Selector_new_val = -1;

	if (attr_Instrument_Selector_quality == Tango::ATTR_INVALID) tfsm->clear();
	

	#ifdef _DBG_STOP
		cout << "Leaving AxisG2Selector::Stop() !" << endl;
	#endif 
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::stop
}
//--------------------------------------------------------
/**
 *	Command Save related method
 *	Description: Save current position on current user target
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevString AxisG2Selector::save()
{
	Tango::DevString argout;
	DEBUG_STREAM << "AxisG2Selector::Save()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::save) ENABLED START -----*/
	//	Add your own code

        std::stringstream ss;

	string thiscmd;
        thiscmd =  __func__ + string("() ");

	if ( state() == Tango::MOVING ){
		string ss("Save not allowed when MOVING");
		thiscmd += ss;
        	hist->push_end(thiscmd);
		cout << thiscmd << endl;
		Tango::Except::throw_exception(
			(const char *) "Command not allowed",
			(const char *) ss.c_str(),
			(const char *) "AxisG2Selector::save()");
	}

	if (!(*attr_UserConfig_read)) {
		string ss("Save not allowed in DEFAULT Config mode");
		thiscmd += ss;
        	hist->push_end(thiscmd);
		cout << thiscmd << endl;
		Tango::Except::throw_exception(
			(const char *) "Command not allowed",
			(const char *) ss.c_str(),
			(const char *) "AxisG2Selector::save()");
	}

	if (attr_Instrument_Selector_quality != Tango::ATTR_VALID) {
		string ss("Save not allowed in INVALID target");
		thiscmd += ss;
		cout << thiscmd << endl;
        	hist->push_end(thiscmd);
		Tango::Except::throw_exception(
			(const char *) "Command not allowed",
			(const char *) ss.c_str(),
			(const char *) "AxisG2Selector::save()");
	}

	Tango::DevShort currentTrg = *attr_Selector_read; // anche se ....
	vector<target_source_t> trg = utrgs[currentTrg].trg_src();
       	vector<source_state_dval_t>::iterator svit;

	#ifdef _DBG_SAVE
		cout << endl;
		cout << "AxisG2Selector::Save()  - " << device_name << " ... entering..." << endl;

        	for (svit = sources_val.begin(); svit != sources_val.end(); ++svit){
			cout << "source_idx = " << (*svit).source_idx << " ";
			cout << sourcesIdx2Name((*svit).source_idx) << " ";
			cout << "val = " << (*svit).val << " ";
			cout << endl;
		}

                for (vector<target_source_t>::iterator tsit=trg.begin(); tsit != trg.end(); ++tsit){
                	cout << "source_idx= "    << (*tsit).source_idx << "|";
                       	cout << "positionValue= " << (*tsit).positionValue << "|";
                       	cout << "positionDelta= " << (*tsit).positionDelta << " ";
			cout << endl;
		}
		cout << endl;
	#endif /*_DBG_SAVE */


        for (vector<target_source_t>::iterator tsit=trg.begin(); tsit != trg.end(); ++tsit){
        	for (svit = sources_val.begin(); svit != sources_val.end(); ++svit){
			if ((*tsit).source_idx == (*svit).source_idx){
				(*tsit).positionValue = (*svit).val;
				#ifdef _DBG_SAVE
					cout << sourcesIdx2Name((*svit).source_idx) << " " << (*svit).val << " ... copied." << endl;
				#endif /*_DBG_SAVE */
			}
		}
	}

	// il nuovo target e' pronto e memorizzato in locale: trg
	Target newutrg = utrgs[currentTrg];
	newutrg.trg_src(trg);

	// il nuovo target e' diverso dagli altri?
	int k;
	for (k=0; k<utrgs.size(); k++){
		if ( k != currentTrg ) {
			if ( !(utrgs[k] != newutrg) ) {
				string ss("Error: new target already exist!");
				thiscmd += ss;
        			hist->push_end(thiscmd);
				cout << thiscmd << endl;
                		Tango::Except::throw_exception (
                        		(const char *)"AxisG2Selector",
                                	(const char *) ss.c_str(),
                                	(const char *)"AxisG2Selector::save()");
			}
		}
	}


	// aggiorno nel vettore degli User targets il nuovo target
	utrgs[currentTrg].trg_src(trg);
	

	
	vector<string> newucongif;
	bool ret = Targets2Config(utrgs, newucongif);

	Tango::DbDatum _attr_prop("Targets");
        _attr_prop << newucongif;
        if ( !put_memorized_attribute(this, "UserConfig", _attr_prop) ){
                                //INFOLOG("AxisG2Selector::write_UserConfigData(): Error in put new memorized value");
				string ss("Error in put new memorized value");
				thiscmd += ss;
        			hist->push_end(thiscmd);
				cout << thiscmd << endl;
                                Tango::Except::throw_exception (
                                        (const char *)"AxisG2Selector",
                                        (const char *) ss.c_str(),
                                        (const char *)"AxisG2Selector::save()");
        }


	argout=Tango::string_dup("DONE");

	thiscmd += "DONE: |";

	for ( vector<string>::iterator sit=newucongif.begin(); sit!=newucongif.end(); sit++){
		thiscmd += *sit;
		thiscmd += "|";
	}

	cout << thiscmd << endl;
        hist->push_end(thiscmd);
	
	#ifdef _DBG_SAVE
		cout << "AxisG2Selector::Save()  - " << device_name << " ... leaving..." << endl;
	#endif /*_DBG_SAVE */
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::save
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetTPos related method
 *	Description: GetTPos(selector,attribute)
 *               return target_position,delta
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevVarDoubleArray *AxisG2Selector::get_tpos(const Tango::DevVarLongStringArray *argin)
{
	Tango::DevVarDoubleArray *argout;
	DEBUG_STREAM << "AxisG2Selector::GetTPos()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Selector::get_tpos) ENABLED START -----*/
	
	//	Add your own code

        std::stringstream ss;

	string thiscmd;
        thiscmd =  __func__ + string("() ");

	argout = new Tango::DevVarDoubleArray();
	argout->length(2);

	#ifdef _DBG_GETTPOS
		cout <<"argout->length() = " << argout->length() << endl;
	#endif /* _DBG_GETTPOS */

	int sl = argin->svalue.length();
	int ll =  argin->lvalue.length();

	#ifdef _DBG_GETTPOS
	#endif /* _DBG_GETTPOS */


	#ifdef _DBG_GETTPOS
		cout << "sl = argin->svalue.length() = " << sl << endl;
		cout << "ll = argin->lvalue.length() = " << ll << endl;
	#endif /* _DBG_GETTPOS */

	if ( (sl != ll) || (sl != 1) || (ll != 1) ) {
		string ss("Error: in quantity for (selector,attribute)");
		thiscmd += ss;
        	hist->push_end(thiscmd);
		cout << thiscmd << endl;
       		Tango::Except::throw_exception (
              		(const char *)"AxisG2Selector",
                       	(const char *) ss.c_str(),
                       	(const char *)"AxisG2Selector::get_tpos()");
	}


	#ifdef _DBG_GETTPOS
		cout << "argin->svalue[0]) = " << argin->svalue[0] << endl;
	#endif /* _DBG_GETTPOS */
	
	map<string, int>::iterator it;
	int idx = -1;
	it = nick2idx.find(string(argin->svalue[0]));
  	if (it != nick2idx.end()) idx = (*it).second; 

	if ( idx == -1 ) {
		string ss("Error: attribute not found");
		thiscmd += ss;
        	hist->push_end(thiscmd);
		cout << thiscmd << endl;
       		Tango::Except::throw_exception (
              		(const char *)"AxisG2Selector",
                       	(const char *) ss.c_str(),
                       	(const char *)"AxisG2Selector::get_tpos()");
	}
	

	int sel = argin->lvalue[0];

	#ifdef _DBG_GETTPOS
		cout << "argin->lvalue[0]) = " << argin->lvalue[0] << endl;
	#endif /* _DBG_GETTPOS */

	if ( (sel<0) || (sel>trgs_in_use->size()) ){
		string ss("Error: selector value invalid");
		thiscmd += ss;
        	hist->push_end(thiscmd);
		cout << thiscmd << endl;
       		Tango::Except::throw_exception (
              		(const char *)"AxisG2Selector",
                       	(const char *) ss.c_str(),
                       	(const char *)"AxisG2Selector::get_tpos()");
	}

	vector<target_source_t> ts = trgs_in_use->at(sel).trg_src();
	vector<target_source_t>::iterator tsit = ts.end();
	for (tsit = ts.begin(); tsit != ts.end(); ++tsit){
		if ( (*tsit).source_idx == idx ) break;
	}
	if ( tsit != ts.end() ) {
		#ifdef _DBG_GETTPOS
			cout << "Found!" << endl;
			cout << " P=" << (*tsit).positionValue << " D=" << (*tsit).positionDelta << endl;
		#endif /* _DBG_GETTPOS */
		(*argout)[0] = (*tsit).positionValue;
		(*argout)[1] = (*tsit).positionDelta;
	} else {
		#ifdef _DBG_GETTPOS
			cout << "NOT Found!" << endl;
		#endif /* _DBG_GETTPOS */
		(*argout)[0] = nan("");
		(*argout)[1] = nan("");
	}

	ss.str("");
	ss << " P=" << (*argout)[0] << " D=" << (*argout)[1];
	thiscmd += ss.str();

	cout << thiscmd << endl;
        hist->push_end(thiscmd);

	#ifdef _DBG_GETTPOS
		cout << "Leaving ..." << endl;
	#endif /* _DBG_GETTPOS */
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::get_tpos
	return argout;
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2Selector::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(AxisG2Selector::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::add_dynamic_commands
}

/*----- PROTECTED REGION ID(AxisG2Selector::namespace_ending) ENABLED START -----*/

//	Additional Methods


/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::namespace_ending
} //	namespace
