/*----- PROTECTED REGION ID(AxisG2SelectorStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2SelectorStateMachine.cpp
//
// description : State machine file for the AxisG2Selector class
//
// project :     Selector Generation2
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// Author: abrami
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <AxisG2Selector.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::AxisG2SelectorStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace AxisG2Selector_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_Instrument_allowed()
 *	Description : Execution allowed for Instrument attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_Instrument_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Instrument attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::InstrumentStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::InstrumentStateAllowed_WRITE

	//	Not any excluded states for Instrument attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::InstrumentStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::InstrumentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_Selector_allowed()
 *	Description : Execution allowed for Selector attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_Selector_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Selector attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::SelectorStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::SelectorStateAllowed_WRITE

	//	Not any excluded states for Selector attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::SelectorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::SelectorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_DeviceState_allowed()
 *	Description : Execution allowed for DeviceState attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_DeviceState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DeviceState attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::DeviceStateStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::DeviceStateStateAllowed_WRITE

	//	Not any excluded states for DeviceState attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::DeviceStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::DeviceStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_DeviceStatus_allowed()
 *	Description : Execution allowed for DeviceStatus attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_DeviceStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DeviceStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::DeviceStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::DeviceStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_Updater_allowed()
 *	Description : Execution allowed for Updater attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_Updater_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Updater attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::UpdaterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::UpdaterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_TrajectoryFSM_allowed()
 *	Description : Execution allowed for TrajectoryFSM attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_TrajectoryFSM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TrajectoryFSM attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::TrajectoryFSMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::TrajectoryFSMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_UserConfig_allowed()
 *	Description : Execution allowed for UserConfig attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_UserConfig_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for UserConfig attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::UserConfigStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::UserConfigStateAllowed_WRITE

	//	Not any excluded states for UserConfig attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::UserConfigStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::UserConfigStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_ExtStatus_allowed()
 *	Description : Execution allowed for ExtStatus attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_ExtStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ExtStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::ExtStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::ExtStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_UserConfigData_allowed()
 *	Description : Execution allowed for UserConfigData attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_UserConfigData_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for UserConfigData attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::UserConfigDataStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::UserConfigDataStateAllowed_WRITE

	//	Not any excluded states for UserConfigData attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::UserConfigDataStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::UserConfigDataStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_History_allowed()
 *	Description : Execution allowed for History attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_History_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for History attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::HistoryStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::HistoryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_Position_allowed()
 *	Description : Execution allowed for Position attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_Position_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::PositionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::PositionStateAllowed_WRITE

	//	Not any excluded states for Position attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::PositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::PositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_DeltaPosition_allowed()
 *	Description : Execution allowed for DeltaPosition attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_DeltaPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DeltaPosition attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Selector::DeltaPositionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::DeltaPositionStateAllowed_WRITE

	//	Not any excluded states for DeltaPosition attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Selector::DeltaPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::DeltaPositionStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_GetInstrumentList_allowed()
 *	Description : Execution allowed for GetInstrumentList attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_GetInstrumentList_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetInstrumentList command.
	/*----- PROTECTED REGION ID(AxisG2Selector::GetInstrumentListStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::GetInstrumentListStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_AxisInit_allowed()
 *	Description : Execution allowed for AxisInit attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_AxisInit_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInit command.
	/*----- PROTECTED REGION ID(AxisG2Selector::AxisInitStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::AxisInitStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(AxisG2Selector::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_Save_allowed()
 *	Description : Execution allowed for Save attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_Save_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Save command.
	/*----- PROTECTED REGION ID(AxisG2Selector::SaveStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::SaveStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Selector::is_GetTPos_allowed()
 *	Description : Execution allowed for GetTPos attribute
 */
//--------------------------------------------------------
bool AxisG2Selector::is_GetTPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetTPos command.
	/*----- PROTECTED REGION ID(AxisG2Selector::GetTPosStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::GetTPosStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(AxisG2Selector::AxisG2SelectorStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::AxisG2SelectorStateAllowed.AdditionalMethods

}	//	End of namespace
