#include "AxisG2Selector.h"


namespace AxisG2Selector_ns
{

TrajectoryFSM::TrajectoryFSM(AxisG2Selector *dev){
	_state	= FSM_WAIT;
	_tr	= FSMT_NOP;
	_dev 	= dev;
	_cnt 	= 0;
}

TrajectoryFSM::~TrajectoryFSM(){
}


void  TrajectoryFSM::fsm(TrajectoryFSMTransitions_t tr, Target trg){           // proceed with FSM

	bool retval = false;

	#ifdef _DBG_FSM
		cout << "FSM :: status : " << status() << " " ;
		cout << "Working_trg : " << _working_trg.name();
		cout << " _cnt= " << _cnt;
		cout << " ";
	#endif /* _DBG_FSM */

	//=========================
	// handle soon:

        if (tr == FSMT_ABORT){
			#ifdef _DBG_FSM_TR_ABORT
				std::cout << "TrajectoryFSM::fsm() :: received FSMT_ABORT !" << std::endl;
			#endif /* _DBG_FSM_TR_ABORT */
			if ( !_working_trg.name().empty()) _working_trg.stop(_dev->sources);
			else {
			#if 0
				vector<sourceDev2_t>::iterator sit;
                		for (sit=_dev->sources.begin(); sit<_dev->sources.end(); sit++){
					if ((*sit).stopcmd != "")
						(*sit).dp->command_inout((*sit).stopcmd);
				};
			#else
				retval = _dev->sourcesStopAll();
			#endif
			};
                        _tr	= FSMT_NOP;
                        _state	= FSM_WAIT;
			_cnt    = 0;
			return;
        }

	//=========================
	// accept tr only in state:

	switch (_state){
                case FSM_WAIT:
			_working_tr = tr;
			_working_trg = trg;
			break;
		default:
			break;
	}

	#ifdef _DBG_FSM
		cout << "transition : " << TrajectoryFSMTransitions[_working_tr] << " ";
	#endif /* _DBG_FSM */

	//=========================
	// handle transition

        switch (_working_tr) {

                default:
                case FSMT_NOP:
                        break;

                case FSMT_ABORT:
                        _tr	= FSMT_NOP;
                        _state	= FSM_WAIT;
			_cnt    = 0;
                        break;

                case FSMT_GOTO:
			switch (_state){
				case FSM_WAIT:
					if (trg.mode() == MODE_ALL) {
						_working_trg.go_all(_dev->sources, _dev->sources_val);
                        			_state	= FSM_START;
					}
					if (trg.mode() == MODE_SEQ) {
						_working_trg.go_seq(_dev->sources, _dev->sources_val);
                        			_state	= FSM_START;
					}
					break;
				case FSM_START:
					_state  = FSM_WAIT_TARGET;
					break;
				case FSM_WAIT_TARGET:
					_working_trg.update(_dev->sources_val);
					_working_trg.updateState(_dev->sources);
					if ( _working_trg.state() != Tango::MOVING )  {
						if ( _working_trg.onTarget() )  _state = FSM_TARGET_DONE;
						else {
							_cnt ++;
							if ( _cnt > 10 ) _state  = FSM_TARGET_ERROR;
						}
					};
					break;
				case FSM_TARGET_ERROR:
				case FSM_TARGET_DONE:
					_state = FSM_WAIT;
					_tr = FSMT_NOP;
					_cnt    = 0;
					_working_trg.stop();
					break;
				default:
					break;
			}
                        break;

#if 0
                case FSMT_AXISINIT:
			switch (_state){
				case FSM_WAIT:
					if (mode == MODE_ALL) {
						//_working_trg.go_all(_dev->sources, _dev->sources_val);
                        			_state	= FSM_WAIT_AXISINIT;
					}
					break;
				case FSM_WAIT_AXISINIT:
					if ... _state  = FSM_DONE;
					break;
				case FSM_DONE:
					_state = FSM_WAIT;
					_tr = FSMT_NOP;
					break;
				default:
					break;
			}
                        break;
#endif

	}

	#ifdef _DBG_FSM
		cout << "   ..... FSM end!" << endl;;
	#endif /* _DBG_FSM */


}


} //namespace
