#include <AxisG2Selector.h>



namespace AxisG2Selector_ns
{


bool AxisG2Selector::parseTargets(vector<string>& targets,  vector<Target>& trgs){

        //      Targets:        una lista di
        //  TargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]
        //
        //  la terna nickName:positionValue:positionDelta si ripete piu` volte,
        //  nickName non puo` essere ripetuto
        //  nickName deve essere presente in AxisDevices

	// Con le sequenze:
	// TargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta][{nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]}]


        //  vector<string>  targets;

	// typedef struct {
	//         int source_idx;
	//         double positionValue;
	//         double positionDelta;
	// } target_source_t;


	#ifdef _DBG_PARSE_TARGETS
		cout << endl;
		cout << "parseTargets(targets, trgs) .... entering" << endl;
	#endif /* _DBG_PARSE_TARGETS */

	vector<string> a, sts;
	Target trg;
	target_source_t ts;
	bool sequence_f = false;
	string trg_conf("");
	string seq_conf("");
        for (size_t j=0; j<targets.size(); j++ ){
		trg_conf = targets[j];
		size_t found;
        	found = targets[j].find_first_of("{");
        	if (found != string::npos ) {	// FOUND START SEQUENCE
			#ifdef _DBG_PARSE_SEQ_TARGETS
				std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: FOUND START SEQUENCE" << std::endl;
			#endif
			trg_conf = targets[j].substr(0, found);
			string reminder = targets[j].substr(found+1); // exclude "{"
        		found = reminder.find_last_of("}");
        		if (found != string::npos ) {	// FOUND END SEQUENCE
				seq_conf = reminder.substr(0, found); // exclude "}"
				sequence_f = true;
				trg.mode(MODE_SEQ);
				#ifdef _DBG_PARSE_SEQ_TARGETS
					std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: FOUND END SEQUENCE" << std::endl;
					std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: SEQUENCE=|" << seq_conf << "|" << std::endl;
				#endif
			}
		} else {
			sequence_f = false;
			//
			// default: MODE_ALL
			//
			trg.mode(MODE_ALL);
			trg_conf = targets[j];
		}

		//
		//  "usual" part of target...
		//
                a = splitby(trg_conf.c_str(), ';');
                if (a.size() >= 1 ) trg.name(a[0]);
                if (a.size() >= 2 ) trg.stateOnTarget(a[1]);

		size_t b = 3;
		map<string, int>::iterator mit;

		bool source_found(false);
		
		while ( a.size() >= b ){
			#ifdef _DBG_PARSE_TARGETS
				cout << "Searching: ";
				cout << a[b-1];
				cout << endl;
			#endif /* _DBG_PARSE_TARGETS */

			sts = splitby(a[b-1].c_str(), ':');

			if ( sts.size()== 3 ){
				mit = nick2idx.find(sts[0]);
	  			if (mit != nick2idx.end()){
					#ifdef _DBG_PARSE_TARGETS
						cout << "Found! " << sts[0] << endl;
					#endif /* _DBG_PARSE_TARGETS */

					source_found = true;
					ts.source_idx = nick2idx[sts[0]];
					ts.positionValue = (double)atof(sts[1].c_str());
					ts.positionDelta = (double)atof(sts[2].c_str());

					trg.push_trg_src(ts);

				} else {
					#ifdef _DBG_PARSE_TARGETS
						cout << "NOT Found! " << sts[0] << endl;
					#endif /* _DBG_PARSE_TARGETS */
					source_found = false;
				}
			}
			b += 1;
		}

		//
		//  "sequence" part of target...
		//
		if (sequence_f){
			#ifdef _DBG_PARSE_SEQ_TARGETS
				std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: SEQUENCE=|" << seq_conf << "| at target: " << trg.name()  << std::endl;
			#endif
                	a = splitby(seq_conf.c_str(), ';');
			for (b = 0; b < a.size(); b++){
				#ifdef _DBG_PARSE_SEQ_TARGETS
					std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: SEQUENCE ... ";
					cout << "Searching: ";
					cout << a[b];
					cout << endl;
				#endif /* _DBG_PARSE_SEQ_TARGETS */
	
				sts = splitby(a[b].c_str(), ':');
	
				if ( sts.size()== 3 ){
					mit = nick2idx.find(sts[0]);
		  			if (mit != nick2idx.end()){
						#ifdef _DBG_PARSE_SEQ_TARGETS
							std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: SEQUENCE ... ";
							cout << "Found! " << sts[0] << endl;
						#endif /* _DBG_PARSE_SEQ_TARGETS */
	
						source_found = true;
						ts.source_idx = nick2idx[sts[0]];
						ts.positionValue = (double)atof(sts[1].c_str());
						ts.positionDelta = (double)atof(sts[2].c_str());
	
						trg.push_trg_src_seq(ts);
	
					} else {
						#ifdef _DBG_PARSE_SEQ_TARGETS
							std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: SEQUENCE ... ";
							cout << "NOT Found! " << sts[0] << endl;
						#endif /* _DBG_PARSE_SEQ_TARGETS */
						source_found = false;
					}
				}
			}
		}

		if (source_found) trgs.push_back(trg);
		else return false;

		trg.clear_trg_src();
		trg.clear_trg_src_seq();
	};

	#ifdef _DBG_PARSE_TARGETS
		vector<Target>::iterator tit;
		for (tit=trgs.begin(); tit != trgs.end(); ++tit){
			cout << (*tit).name() << " ";
			cout << Tango::DevStateName[(*tit).stateOnTarget()] << " ";
			vector<target_source_t> trg = (*tit).trg_src();
			for (vector<target_source_t>::iterator tsit=trg.begin(); tsit != trg.end(); ++tsit){
				cout << (*tsit).source_idx << "|";
				cout << (*tsit).positionValue << "|";
				cout << (*tsit).positionDelta << " ";
			}
			cout << endl;
		}
	#endif /* _DBG_PARSE_TARGETS */


	#ifdef _DBG_PARSE_TARGETS
		cout << "parseTargets(targets, trgs) .... leaving" << endl;
		cout << endl;
	#endif /* _DBG_PARSE_TARGETS */
	return true;
}
	
} //	namespace
