#ifndef _SEQERRORS_H_
#define _SEQERRORS_H_

typedef enum {
	TH_FORCEDEXIT = -5,
	TH_ASKABORT = -4,
	TH_NOTHREAD = -3,
	TH_THREAD = -2,
	TH_RUNNING = -1,
	TH_EXIT_OK = 0
} th_err_value_t;


typedef struct {
	th_err_value_t th_err;
        string th_desc;
} th_err_t;

inline string th_error(th_err_t e){
	switch (e.th_err){
		case TH_FORCEDEXIT: return "Forced exit in thread"; break;
		case TH_ASKABORT:   return "Ask thread to abort"; break;
		case TH_NOTHREAD:   return "No thread"; break;
		case TH_THREAD:     return "Thread present"; break;
		case TH_RUNNING:    return "Thread running"; break;
		case TH_EXIT_OK:    return "Thread exit success"; break;
		default:	    return "-?-"; break;
	}
	return "Undef!";
}

#endif /* _SEQERRORS_H_ */
