#include "AxisG2Selector.h"

#define STRINGSIZE 128



namespace AxisG2Selector_ns
{
string AxisG2Selector::sourcesIdx2Name(int index){
	string nickName = "UNKNOWN";

        vector<sourceDev2_t>::iterator sit;
        for (sit=sources.begin(); sit<sources.end(); sit++){
                if ( ((*sit).configured) && ((*sit).index == index) ) return (*sit).nickName;
	}

	return nickName;
}


bool AxisG2Selector::sourcesStopAll(){
	bool retval = true;

        vector<sourceDev2_t>::iterator sit;
        for (sit=sources.begin(); sit<sources.end(); sit++){
                if ((*sit).configured){
			try {
				if ((*sit).stopcmd != "")
					(*sit).dp->command_inout((*sit).stopcmd);
                        } catch(...) {
                                string ss(ag2s_error_str(AG2S_E007));
                                ss.append(" : exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
                                cout << ss << endl;
                                append_status(ss, true);
				retval = false;
                        }

                };
        };


	return retval;
}

bool AxisG2Selector::sourcesAxisInit(TrajectoryMode_t mode, string &err){
	#ifdef _DBG_AXISINIT
		cout << "AxisG2Selector::sourcesAxisInit()" << endl;
	#endif /* _DBG_AXISINIT */
	bool retval = true;
	err = "";

        vector<sourceDev2_t>::iterator sit;
	int stop_requests = 0;

	switch (mode) {
	  case MODE_ALL:
		#ifndef _AXISINIT_ASYNC_
	        for (sit=sources.begin(); sit<sources.end(); sit++){
	                if ((*sit).configured){
				try {
					#ifdef _DBG_AXISINIT
						cout << "AxisG2Selector::sourcesAxisInit() name:" << (*sit).dp->name() << endl;
						cout << "AxisG2Selector::sourcesAxisInit() :" << (*sit).initcmd << endl;
						cout << "AxisG2Selector::sourcesAxisInit() :" << (*sit).stopcmd << endl;
						cout << "AxisG2Selector::sourcesAxisInit() state:" << (*sit).dp->state() << endl;
						cout << "AxisG2Selector::sourcesAxisInit() status:" << (*sit).dp->status() << endl;
					#endif /* _DBG_AXISINIT */

					if ((*sit).stopcmd != "")
						(*sit).dp->command_inout((*sit).stopcmd);

					#ifdef _DBG_AXISINIT
						cout << "AxisG2Selector::sourcesAxisInit() state:" << (*sit).dp->state() << endl;
						cout << "AxisG2Selector::sourcesAxisInit() status:" << (*sit).dp->status() << endl;
					#endif /* _DBG_AXISINIT */
					
					if ((*sit).initcmd != "")
						(*sit).dp->command_inout((*sit).initcmd);

                       		} catch(Tango::DevFailed &e) {
                                	cout << e.errors[0].desc << endl;
	                                string ss(ag2s_error_str(AG2S_E008));
	                                ss.append(" : exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
	                                cout << ss << endl;
					err.append(" ");
					err.append(ss);
					retval = false;
	                        } catch(...) {
	                                string ss(ag2s_error_str(AG2S_E008));
	                                ss.append(" : generic exception on Tango::DeviceProxy(" + (*sit).dev + ")!");
	                                cout << ss << endl;
					err.append(" ");
					err.append(ss);
					retval = false;
	                        }
	                }; // if configured
	        }; // for
	
		#else
	        for (sit=sources.begin(); sit<sources.end(); sit++){
	                if ((*sit).configured){
				(*sit).stop_request_id = -1;
				if ((*sit).stopcmd != "") {
					(*sit).stop_request_id = (*sit).dp->command_inout_asynch((*sit).stopcmd);
					cout << "AxisG2Selector::sourcesAxisInit(): " << (*sit).dp->name() << " stop() sent!" << endl;
				}
			}
		}
	        for (sit=sources.begin(); sit<sources.end(); sit++){
	                if ((*sit).configured && ((*sit).stop_request_id >=0)) stop_requests++;
		}
		while (stop_requests){
		        for (sit=sources.begin(); sit<sources.end(); sit++){
		                if ((*sit).configured){
					//- get results
					if ((*sit).stop_request_id >= 0) {
						try {
							// void stop(void)
							(*sit).dp->command_inout_reply((*sit).stop_request_id);
							// qui se ho ricevuto reply
							cout << "AxisG2Selector::sourcesAxisInit(): " << (*sit).dp->name() << " got stop() reply!" << endl;
							(*sit).stop_request_id = -1;
							stop_requests --;
	
							if ((*sit).initcmd != "") (*sit).axisinit_request_id = (*sit).dp->command_inout_asynch((*sit).initcmd);
	                       			} catch(Tango::DevFailed &e) {
	                                		//cout << e.errors[0].desc << endl;
							//wait
						}
					}
				}
			}
		}
		#endif
	  default:
		break;
	}
	
	return retval;
}


} //    namespace

