#ifndef __TFSM_H__
#define __TFSM_H__

#include "Types.h"
#include "Targets.h"
//include "AxisG2Selector.h"



namespace AxisG2Selector_ns
{

class AxisG2Selector;

typedef struct {
        int source_idx;
        string cmd;
        double cmd_val;
} cmd_source_t;

typedef struct {
	string transition;
	vector<cmd_source_t> cmds;
} tcmds_t;

class TFSM {

private:
	AxisG2Selector *	_dev;
	string 			_status;
	vector<tcmds_t>		_tcmds;
	bool			_enable;

public:
	TFSM(AxisG2Selector * dev);
	~TFSM();

	bool		addTcmds(string TCmds);
	void		dumpTcmds();
	vector<string>	str_getTcmds();

	void		tfsm(string new_status);           // proceed with FSM
	string 		status()		{ return _status; };

	void		enable()	{_enable = true;};
	void		disable()	{_enable = false;};

	void		clear()		{_status="";};

};


} //namespace
#endif /* __TFSM_H__ */
