#include <AxisG2Selector.h>


namespace AxisG2Selector_ns
{



        //      Targets:        una lista di
        //  TargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]
        //
        //  la terna nickName:positionValue:positionDelta si ripete piu` volte,
        //  nickName non puo` essere ripetuto
        //  nickName deve essere presente in AxisDevices

        //  vector<string>  targets;

/*
typedef struct {
	int source_idx;
	double positionValue;
	double positionDelta;
} target_source_t;
*/


bool    Target::stateOnTarget(string st){

  Tango::DevState s;

        if      (st == "ON")	  { s =  Tango::ON; }
        else if (st == "OFF")	  { s =  Tango::OFF; }
        else if (st == "OPEN") 	  { s =  Tango::OPEN; }
        else if (st == "CLOSE")   { s =  Tango::CLOSE; }
        else if (st == "INSERT")  { s =  Tango::INSERT; }
        else if (st == "EXTRACT") { s =  Tango::EXTRACT; }
        else if (st == "STANDBY") { s =  Tango::STANDBY; }
        else if (st == "ALARM")   { s =  Tango::ALARM; }
        else { s =  Tango::UNKNOWN; }

	_state_on_target = s;
	return true;
}

bool    Target::onTarget(){
	return _on_target;
}

bool    Target::update(vector<source_state_dval_t> &sources_val){     // legge i valori e aggiorna il suo state, ritorna false se qualche problema per acquisire i dati

	_on_target = true;
	for (vector<target_source_t>::iterator tsit=_trgSrc.begin(); tsit != _trgSrc.end(); ++tsit){
		#ifdef _DBG_TARGET_UPDATE
			cout << "source_idx: " << (*tsit).source_idx << "!" << " ";
		#endif /* _DBG_TARGET_UPDATE */
		
		bool ont = true;
		vector<source_state_dval_t>::iterator svit;
        	for (svit = sources_val.begin(); svit != sources_val.end(); ++svit){
			if ((*svit).source_idx == (*tsit).source_idx){
				if ( fabs((*tsit).positionValue - (*svit).val) > (*tsit).positionDelta ) ont=_on_target = false; 
				if ( (*svit).quality == Tango::ATTR_INVALID ) ont=_on_target = false;
				#ifdef _DBG_TARGET_UPDATE
					cout << "     | ";
					cout << (*svit).val << "|";
					cout << AttrQualityName[(*svit).quality] << " | ";
					cout << (*tsit).positionValue << "| ";
					cout << (*tsit).positionDelta << " || ";
					cout << (ont?"on_target":"off_target");
					cout << endl;
				#endif /* _DBG_TARGET_UPDATE */
				break;
			}
		}
	}
	#ifdef _DBG_TARGET_UPDATE
		cout << "---------- Target " << _name << " : " << (_on_target?"on_target":"off_target") << endl;
		cout << endl;
	#endif /* _DBG_TARGET_UPDATE */
	return true;
}

bool Target::updateState(vector<sourceDev2_t> &sources){
  {using namespace Tango;

	#ifdef _DBG_TARGET_UPDATE_STATE
		cout << endl << "Target::updateState(" << _name << ") : " << endl;
	#endif /* _DBG_TARGET_UPDATE_STATE */


	DevState table[14][14] = {
    	//	oldState         ON      OFF      CLOSE     OPEN    INSERT  EXTRACT  MOVING   STANDBY  FAULT    INIT     RUNNING  ALARM    DISABLE  UNKNOWN
	// inState
	/* ON */             { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* OFF */            { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* CLOSE */          { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* OPEN */           { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* INSERT */         { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* EXTRACT */        { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* MOVING */         { MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING,  MOVING },
	/* STANDBY */        { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* FAULT */          { ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   MOVING,  ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   DISABLE, ALARM },
	/* INIT */           { ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   MOVING,  ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   DISABLE, ALARM },
	/* RUNNING */        { STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, STANDBY, MOVING,  STANDBY, ALARM,   STANDBY, STANDBY, ALARM,   DISABLE, STANDBY },
	/* ALARM */          { ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   MOVING,  ALARM,   ALARM,   ALARM,   ALARM,   ALARM,   DISABLE, ALARM },
	/* DISABLE */        { DISABLE, DISABLE, DISABLE, DISABLE, DISABLE, DISABLE, MOVING,  DISABLE, DISABLE, DISABLE, DISABLE, DISABLE, DISABLE, DISABLE },
	/* UNKNOWN */        { UNKNOWN, UNKNOWN, UNKNOWN, UNKNOWN, UNKNOWN, UNKNOWN, MOVING,  UNKNOWN, UNKNOWN, UNKNOWN, UNKNOWN, UNKNOWN, DISABLE, UNKNOWN }
	};


	Tango::DevState s = Tango::UNKNOWN;
	Tango::DevState ns = Tango::UNKNOWN;

	for (vector<target_source_t>::iterator tsit=_trgSrc.begin(); tsit != _trgSrc.end(); ++tsit){
                if ( (sources[(*tsit).source_idx].configured) ){
			ns = sources[(*tsit).source_idx].state;
			#ifdef _DBG_TARGET_UPDATE_STATE
				cout << "______ ";
				cout <<  sources[(*tsit).source_idx].nickName << " : " << Tango::DevStateName[ns] << endl;
			#endif /* _DBG_TARGET_UPDATE_STATE */
			s = table[ns][s];
		}
	}

        if (moving_thread != NULL) {
		switch (th_err.th_err){
			default:
        		case TH_FORCEDEXIT:
        		case TH_ASKABORT:
        		case TH_NOTHREAD:
        		case TH_THREAD:
        		case TH_EXIT_OK:
				break;
        		case TH_RUNNING:
				s = Tango::MOVING;
				break;
		}
       	}

	_state = s;

	#ifdef _DBG_TARGET_UPDATE_STATE
		cout << "Target::updateState(" << _name << ") : " << Tango::DevStateName[_state] << endl;
		cout << endl;
	#endif /* _DBG_TARGET_UPDATE_STATE */

	return true;
  }
}


/********************************************************
*
*
*
********************************************************/

bool    Target::go_all(vector<sourceDev2_t> &sources, vector<source_state_dval_t> &sources_val){

	#ifdef _DBG_TARGET_GO_ALL
		cout << "Entering Target::go_all() ..." << endl;
	#endif /* _DBG_TARGET_GO_ALL */


	for (vector<target_source_t>::iterator tsit=_trgSrc.begin(); tsit != _trgSrc.end(); ++tsit){
	        Tango::DeviceAttribute da;
		double w_val = (*tsit).positionValue;
                if ( (sources[(*tsit).source_idx].configured) ){
			#ifdef _DBG_TARGET_GO_ALL
				cout << "Target::go_all(): " << sources[(*tsit).source_idx].dev << " " << sources[(*tsit).source_idx].attr << " < " << w_val << endl;
			#endif /* _DBG_TARGET_GO_ALL */
                        try {
                                da.set_name(sources[(*tsit).source_idx].attr);
                                switch (sources[(*tsit).source_idx].data_type){
                                        case Tango::DEV_FLOAT:  break;
                                        case Tango::DEV_DOUBLE: { double         double_val = (double)w_val;         da << double_val; }; break;
                                        case Tango::DEV_LONG:   { Tango::DevLong   long_val = (Tango::DevLong)w_val; da << long_val; }; break;
                                        case Tango::DEV_USHORT: { unsigned short     us_val = (unsigned short)w_val; da << us_val; }; break;
                                        case Tango::DEV_SHORT:  { short           short_val = (short)w_val;          da << short_val; }; break;
                                        default:                cout << "Not implemented attr_type= "<< Tango::CmdArgTypeName[sources[(*tsit).source_idx].data_type];
                                }
                                sources[(*tsit).source_idx].dp->write_attribute(da);
                        } catch(...) {
                                string ss(ag2s_error_str(AG2S_E004));
                                ss.append(" : exception on Tango::DeviceProxy(" + sources[(*tsit).source_idx].dev + ")!");
                                cout << ss << endl;
                                //append_status(ss, true);
                        }
                }
        }
	return true;
}
bool    Target::stop(vector<sourceDev2_t> &sources){
        #ifdef _DBG_STOP
		std::cout << "Target::stop() ... !" << std::endl;
        #endif /* _DBG_STOP */

	for (vector<target_source_t>::iterator tsit=_trgSrc.begin(); tsit != _trgSrc.end(); ++tsit){
		if (sources[(*tsit).source_idx].stopcmd != "")
                	sources[(*tsit).source_idx].dp->command_inout(sources[(*tsit).source_idx].stopcmd);
	};
	return true;
}

bool Target::go_seq(vector<sourceDev2_t> &sources, vector<source_state_dval_t> &sources_val){
	// anche nella go_all: sources_val NON sono usati!
	#ifdef _DBG_PARSE_SEQ_TARGETS
        	std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: begin" << std::endl;
        #endif

#if 0
	for (vector<target_source_t>::iterator tsit=_trgSrcSeq.begin(); tsit != _trgSrcSeq.end(); ++tsit){
	        Tango::DeviceAttribute da;
		double w_val = (*tsit).positionValue;
                if ( (sources[(*tsit).source_idx].configured) ){
			#ifdef _DBG_PARSE_SEQ_TARGETS
				cout << "Target::go_seq(): " << sources[(*tsit).source_idx].dev << " " << sources[(*tsit).source_idx].attr << " < " << w_val << endl;
			#endif /* _DBG_PARSE_SEQ_TARGETS */
                        try {
                                da.set_name(sources[(*tsit).source_idx].attr);
                                switch (sources[(*tsit).source_idx].data_type){
                                        case Tango::DEV_FLOAT:  break;
                                        case Tango::DEV_DOUBLE: { double         double_val = (double)w_val;         da << double_val; }; break;
                                        case Tango::DEV_LONG:   { Tango::DevLong   long_val = (Tango::DevLong)w_val; da << long_val; }; break;
                                        case Tango::DEV_USHORT: { unsigned short     us_val = (unsigned short)w_val; da << us_val; }; break;
                                        case Tango::DEV_SHORT:  { short           short_val = (short)w_val;          da << short_val; }; break;
                                        default:                cout << "Not implemented attr_type= "<< Tango::CmdArgTypeName[sources[(*tsit).source_idx].data_type];
                                }
                                sources[(*tsit).source_idx].dp->write_attribute(da);
                        } catch(...) {
                                string ss(ag2s_error_str(AG2S_E004));
                                ss.append(" : exception on Tango::DeviceProxy(" + sources[(*tsit).source_idx].dev + ")!");
                                cout << ss << endl;
                                //append_status(ss, true);
                        }
                }
        }
#else
	        if (moving_thread != NULL) {
			#ifdef _DBG_PARSE_SEQ_TARGETS
        			std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: going to kill moving_thread " << std::endl;
			#endif
                	moving_thread->abort();
        	}

                th_err.th_err = TH_NOTHREAD;
                th_err.th_desc.clear();

                try {
                        moving_thread = new SeqMoveThread(this, sources, sources_val);
                } catch (...) {
                        cout << "ERROR in new moving_thread! " << endl;
                        moving_thread = NULL;
                }
                th_err.th_err = TH_THREAD;
                try {
                        if (moving_thread!=NULL) {
                                moving_thread->start();
                                status_msg = "Moving sequence in progress...";
				#ifdef _DBG_PARSE_SEQ_TARGETS
        				std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: " << status_msg << std::endl;
        			#endif
                        }
                } catch (...) {
                        cout << "ERROR in moving_thread.start()! " << endl;
                }

#endif

	#ifdef _DBG_PARSE_SEQ_TARGETS
        	std::cout << __func__ << "()@" << __FILE__ << ":" << __LINE__ << " :: end" << std::endl;
        #endif
	return true;
}

/********************************************************
*
*
*
********************************************************/

bool Target::stop(){
	if (_mode == MODE_SEQ){
	        if (moving_thread != NULL) {
                	moving_thread->abort();
        	}

                th_err.th_err = TH_NOTHREAD;
                th_err.th_desc.clear();
		moving_thread = NULL;
	};
	return true;
}

/********************************************************
*
*
*
********************************************************/

#if 0
bool Target::operator== (const Target &other) const {

vector<target_source_t> trg_src()                       { return _trgSrc; };

	vector<target_source_t>::iterator tsit, tsito;
	bool idx_found;
	for (tsit = _trgSrc.begin(); tsit != _trgSrc.end(); tsit++){
		idx_found = false;
		for (tsito = other.begin(); tsito != other.end(); tsito++) if ( (*tsit).source_idx  == (*tsito).source_idx ) { idx_found = true; break; };
		if ( !idx_found ) return false; // manca un indice/sorgente NON sono perfettamente eguali (potrebbero includere uno l'altro)
	}
}
#endif

bool Target::operator != (Target &other) {

	#ifdef _DBG_TARGET_OPERATORS
		cout << "operator !=  entering..." << endl;
	#endif /* _DBG_TARGET_OPERATORS */

	bool result = false; // di default non sono diversi!

	vector<target_source_t> oth_trg_src = other.trg_src();
	
	// se le dimensioni sono diverse allora o sono diversi oppure uno "include" l'altro

	vector<target_source_t> * p_trg_src_big;
	vector<target_source_t> * p_trg_src_small;

	if (_trgSrc.size() >= oth_trg_src.size()){
		p_trg_src_big = &_trgSrc;
		p_trg_src_small = &oth_trg_src;
	} else {
		p_trg_src_small = &_trgSrc;
		p_trg_src_big = &oth_trg_src;
	}

/*
typedef enum {
        VUOTO,
        DISGIUNTO,
        INTERSECATO
} range_t;
*/

	vector<target_source_t>::iterator tsitb, tsits;
	vector<range_t> rng;

	for (tsitb = p_trg_src_big->begin(); tsitb != p_trg_src_big->end(); tsitb++){
		for (tsits = p_trg_src_small->begin(); tsits != p_trg_src_small->end(); tsits++){
			if ( (*tsitb).source_idx == (*tsits).source_idx ) {
				double m = (*tsitb).positionDelta >= (*tsits).positionDelta ? (*tsitb).positionDelta : (*tsits).positionDelta;
				if ( fabs( (*tsitb).positionValue - (*tsits).positionValue ) > m )  rng.push_back(DISGIUNTO);
				else rng.push_back(INTERSECATO);
			} else {
				rng.push_back(VUOTO);
			}
		}
	}
	

	vector<range_t>::iterator it_rng;
	for (it_rng = rng.begin(); it_rng != rng.end(); it_rng++){
		if ( *it_rng == DISGIUNTO ) {
			result = true;
			break;
		}
	}

	#ifdef _DBG_TARGET_OPERATORS
		cout << "operator !=  leaving... with result: " << (result?"true":"false") << endl;
	#endif /* _DBG_TARGET_OPERATORS */

	return result;
}
} //	namespace
