#ifndef __TARGETS_H__
#define __TARGETS_H__
#include "AxisG2Selector.h"

namespace AxisG2Selector_ns
{
class Target;
class SeqMoveThread;
}

#include "SeqMoveThreadErrors.h"
#include "SeqMoveThread.h"


namespace AxisG2Selector_ns
{


#if 0
typedef struct {
        string nickName;
        string dev;
        string attr;
        string stopcmd;
        string initcmd;
        int index;
        bool is_spectrum;
        string trueValue;
        Tango::DeviceProxy *dp;
        Tango::DevState state;
        bool configured;
        int data_type;
        unsigned long backoff;
        long tmo;
} sourceDev2_t;

        //      Targets:        una lista di
        //  TargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]
        //
        //  la terna nickName:positionValue:positionDelta si ripete piu` volte,
        //  nickName non puo` essere ripetuto
        //  nickName deve essere presente in AxisDevices

        //  vector<string>  targets;

typedef struct {
	int source_idx;
	double positionValue;
	double positionDelta;
} target_source_t;
#endif

class Target {

private:
	string 			_name;
	Tango::DevState 	_state_on_target;
	Tango::DevState 	_state;
	vector<target_source_t>	_trgSrc;
	vector<target_source_t>	_trgSrcSeq;
	bool			_on_target;
	TrajectoryMode_t	_mode;

        friend class SeqMoveThread;
        SeqMoveThread* moving_thread;
        th_err_t th_err;
        string status_msg;

public:
	string		name() 					{ return _name; };
	bool   		name(string n)				{ _name = n; return true; };

	Tango::DevState	stateOnTarget()				{ return _state_on_target; };
	bool		stateOnTarget(Tango::DevState s)	{ _state_on_target = s; return true; };
	bool		stateOnTarget(string st);


	Tango::DevState	state()					{ return _state; };

	void			push_trg_src(target_source_t ts )		{ _trgSrc.push_back(ts); };
	void 			clear_trg_src()					{ _trgSrc.clear(); };
	vector<target_source_t> trg_src()					{ return _trgSrc; };
	void 			trg_src(vector<target_source_t> trg_src) 	{ _trgSrc = trg_src; };

	void			push_trg_src_seq(target_source_t ts )		{ _trgSrcSeq.push_back(ts); };
	void 			clear_trg_src_seq()				{ _trgSrcSeq.clear(); };
	vector<target_source_t> trg_src_seq()					{ return _trgSrcSeq; };
	void 			trg_src_seq(vector<target_source_t> trg_src) 	{ _trgSrcSeq = trg_src; };

	bool		updateState(vector<sourceDev2_t> &sources);
	bool		update(vector<source_state_dval_t> &sources_val);		// legge i valori e aggiorna il suo state, ritorna false se qualche problema per acquisire i dati
	bool 		go();			// invia i cmd di posizionamento, ritorna false se qualche problema ad inviare i cmd
	bool		onTarget();		// true se le posizioni delle sources rimangono all'interno di positionValue +/-positionDelta
						// aggiorna _state.
	bool		go_all(vector<sourceDev2_t> &sources, vector<source_state_dval_t> &sources_val);
	bool		go_seq(vector<sourceDev2_t> &sources, vector<source_state_dval_t> &sources_val);
	bool 		stop(vector<sourceDev2_t> &sources);

	#if 0
	bool 		operator==	(const Target &other) const ;
	#endif

	bool 		operator!=	(Target &other);

	TrajectoryMode_t mode() {return _mode;};
	bool 		mode(TrajectoryMode_t m){ _mode = m; return true;};

	bool 		stop();
};


	
} //	namespace
#endif /* __TARGETS_H__ */
