#include <AxisG2Selector.h>


namespace AxisG2Selector_ns
{
/**
* From Targets (vector<Target>) to Config (vector<string>)
*
*
**/
bool AxisG2Selector::Targets2Config(vector<Target>& trgs, vector<string>& targets){

	#ifdef _DBG_TARGET_2_CONFIG
		cout << "Targets2Config() on " << device_name << " entering..." << endl;

		{
	        std::stringstream ss;
	        vector<Target>::iterator it_trgs;
	        for (it_trgs = trgs.begin(); it_trgs != trgs.end(); it_trgs++){
                	ss.str("");
                	ss << "  TARGET: " << it_trgs->name() << " ";
                	ss << "  .. state on target: " << Tango::DevStateName[it_trgs->stateOnTarget()];
			cout << ss.str() << endl;
                	{
                        	vector<target_source_t>::iterator it_src;
                        	vector<target_source_t> trg_src = it_trgs->trg_src();
                        	for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
                                	ss.str("");
                                	ss << "       ";
                                	ss << "[" << it_src->source_idx << "] ";
                                	ss << sourcesIdx2Name(it_src->source_idx) << " ";
                                	ss << "pos: " << it_src->positionValue << " +/- " << it_src->positionDelta;
					cout << ss.str() << endl;
                       		}
                	};
        	};
		}

	#endif /* _DBG_TARGET_2_CONFIG */


	std::stringstream ss;
	vector<Target>::iterator it_trgs;
        vector<target_source_t>::iterator it_src, it2_src;
        vector<target_source_t> trg_src;

	for (it_trgs = trgs.begin(); it_trgs != trgs.end(); it_trgs++){
              	ss.str("");
               	ss << it_trgs->name() << ";";
               	ss << Tango::DevStateName[it_trgs->stateOnTarget()] << ";";
                trg_src = it_trgs->trg_src();
                for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){
                       	ss << sourcesIdx2Name(it_src->source_idx) << ":";
                       	ss << it_src->positionValue << ":";
                       	ss << it_src->positionDelta;
			it2_src = it_src;
			it2_src++;
			if (it2_src != trg_src.end()) ss << ";";
        	};
		targets.push_back(ss.str());
		#ifdef _DBG_TARGET_2_CONFIG
			cout << ss.str() << endl;
		#endif /* _DBG_TARGET_2_CONFIG */
	}

	#ifdef _DBG_TARGET_2_CONFIG
		cout << "Targets2Config() on " << device_name << " leaving..." << endl;
	#endif /* _DBG_TARGET_2_CONFIG */
	return false;
}

} // namespace
